<?php

namespace Neuron\Person\Controller;

use Neuron\Access\Session;
use Neuron\Actor;
use Neuron\Person\Attribute as AttrModel;
use Neuron\Person\Attributes;

use Neuron\Person\Attribute\Type;
use Neuron\Person\Entities;
use Neuron\Person\Entity;
use Neuron\Person\Detail;

use Neuron\Person\Maps;
use Neuron\Person\Map;
use Neuron\Person\Module;

use Neuron\Employee\Entity as EmpEntity;
use Neuron\Employee\Entities as EmpEntities;

//php PDF
use Mpdf\Mpdf;

//PHP excel
use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\IOFactory;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;
use PhpOffice\PhpSpreadsheet\Cell\DataValidation;
use PhpOffice\PhpSpreadsheet\Worksheet\Worksheet;
use PhpOffice\PhpSpreadsheet\Cell\Coordinate;
use PhpOffice\PhpSpreadsheet\Style\Alignment;
use PhpOffice\PhpSpreadsheet\Style\Color;
use PhpOffice\PhpSpreadsheet\Style\Fill;

use DateTime;

class Index extends \Neuron\Person\Controller
{
	public function indexAction()
	{

		echo ('If you see this, Neuron\Person is loaded properly.');
		return false;
	}

	protected function getView($name, $variables = array())
	{

		/* default layout & view prefix */
		$layout = 'neuron/person/layout/form';
		$prefix = 'neuron/person/form';
		if (!class_exists('Neuron\Application\Framework\Entity')) {
			/* libraries */
			$this->using('jquery', null)
				->using(
					'bootstrap-4',
					null,
					array(
						'https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js',
						'https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js',
						'https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css',
						'https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js'
					)
				)
				->using('fontawesome', null);
		}
		/* get layout n view prefix from config */
		$config = $this->getConfig();
		if (isset($config['person'])) {
			$config = $config['person'];
			$layout = isset($config['formlayout']) ? $config['formlayout'] : $layout;
			$prefix = isset($config['viewprefix']) ? $config['viewprefix'] : $prefix;
		}

		$this->using('nAlert', 9999999);


		/* set layout and view */
		$this->layout($layout);
		$view = new \Zend\View\Model\ViewModel($variables);
		$view->setTemplate($prefix . '/' . strtolower($name));

		return $view;
	}

	public function manageAction()
	{
		if (!isset($_GET['tour'])) {
			if (!file_exists('temp/flagTourPerson.txt')) {
				fopen('temp/flagTourPerson.txt', 'w');
				$this->redirect()->toUrl($this->getPublicUrl() . '/person/index/manage?tour=1');
			}
		}

		$layout = $this->layout();
		// $layout->setVariables(['previous' => '<a href="'.$this->basePath().'/index/my-request">Leave</a>']);
		if (class_exists('Neuron\Employee\Entity')) {
			$layout->setVariables(['current' => 'Manage Employee']);
		} else {
			$layout->setVariables(['current' => 'Manage Person']);
		}

		$this->using('datatable', 19, array(
			'https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js',
			'https://cdn.datatables.net/1.10.19/js/dataTables.bootstrap4.min.js',
			'https://cdn.datatables.net/1.10.19/css/dataTables.bootstrap4.min.css'
		));
		$this->usingJs('bootbox',21,  array(
			'https://cdnjs.cloudflare.com/ajax/libs/bootbox.js/4.4.0/bootbox.min.js'
		));

		$this->using('p-loading', 22);
		$this->usingJs('moment', 23, array(
			'https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.29.1/moment.min.js'
		));
		$this->using('bootstrap-datepicker', 24);
		$this->using('bootstrap-imageupload', 25);;
		$this->using('select2', 26, array(
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/select2.min.js',
			/* ini load sesuai bahasa dari session */
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/i18n/id.js',
			/**/
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/css/select2.min.css',
			'https://cdn.jsdelivr.net/npm/@ttskch/select2-bootstrap4-theme@1.3.2/dist/select2-bootstrap4.min.css',
		));
		$this->using('generic', 30);
		$this->using('jquery.validate', 31, array(
			"https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.19.2/jquery.validate.min.js",
			"https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.19.2/additional-methods.min.js"
		));

		$sessmgt = $this->getSession()->get();

		if (class_exists('Neuron\Document\Entity')) {
			$config = $this->getConfig()['upload_document'];
			if (isset($sessmgt['ref_id'])) {
				$config['location'] = $config['location'] . '/' . $sessmgt['ref_id'];
			}

			$var = 'uploader_document';
			$this->using('plupload', 27);
			$upload = new \Neuron\Upload\Upload($var, $config);
		} else {
			$var = null;
			$upload = null;
		}

		$add = $this->checkGrants('add_employee');
		$edit = $this->checkGrants('edit_employee');
		$remove = $this->checkGrants('remove_employee');
		$detail = $this->checkGrants('detail_employee');
		$setCategory = $this->checkGrants('set_category_employee');
		$setSalary =  $this->checkGrants('set_salary_employee');

		if (class_exists('Neuron\Employee\Entity')) {
			$title 	= $this->translate("Manage Employee");
		} else {
			$title = $this->translate('Person Management');
		}

		$flagSourceExt = $this->getConfigExt('flag_source_ext');

		return $this->getView('manage', get_defined_vars());
	}

	public function downloadListPersonAction()
	{
		// die('here');
		$storage 	= \Neuron\Employee\Entity\Storage::factory($this->getDb(), $this->getConfig());
		$cpersons 	= new EmpEntities($storage);
		
		$params 	= $this->getPostParams();
		$mode 		= \Neuron\Employee\Entity\Storage::LIST_ALL;
		$id 		= null;
		
		if($params['filter_status_id'] !== 'null'){
			$params['status_id'] = $params['filter_status_id'];
		}
		
		if($params['filter_type_id'] !== 'null'){
			$params['type_id'] = $params['filter_type_id'];
		}
			
		$result = $cpersons->load($id, $mode, $params);
		
		foreach($cpersons as $entity){
			
			$tempRows	= $entity->pull();
			$map 		= $entity->_map();
			$user 		= $map->user()->pull();
			/* Hide password  */
			unset($user['password'],$user['language'],$user['entity_id'],$user['create_dtm']);

			$tempRows['person'] = $entity->person()->pull();
			$tempRows['detail'] = $entity->detail()->pull();;
			$tempRows['status'] = $entity->status()->pull();;
			$tempRows['type'] 	= $entity->type()->pull();
			$tempRows['map'] 	= $map->pull();
			$tempRows['user']	= $user;
			
			$rows[] 			= $tempRows;
		}

		$spreadsheet 		= new Spreadsheet();
		$worksheet 			= new Worksheet();

		/* Create Header */
		$sheet = $spreadsheet->getActiveSheet();
		$sheet->setCellValue('A1', 'Daftar Pegawai')->getColumnDimension('A')->setAutoSize(true);
		//$sheet->setCellValue('A2', 'Periode : '. $startdtm . ' s/d ' . $enddtm)->getColumnDimension('A')->setAutoSize(true);
		$sheet->setCellValue('A3', 'No')->getColumnDimension('A')->setAutoSize(true);
		$sheet->setCellValue('B3', 'Kode')->getColumnDimension('B')->setAutoSize(true);
		$sheet->setCellValue('C3', 'Email')->getColumnDimension('B')->setAutoSize(true);
		$sheet->setCellValue('D3', 'Nama Lengkap')->getColumnDimension('C')->setAutoSize(true);
		$sheet->setCellValue('E3', 'Jenis Kelamin')->getColumnDimension('D')->setAutoSize(true);
		$sheet->setCellValue('F3', 'Tanggal Lahir')->getColumnDimension('E')->setAutoSize(true);
		$sheet->setCellValue('G3', 'Tempat Lahir')->getColumnDimension('F')->setAutoSize(true);
		$sheet->setCellValue('H3', 'Tipe')->getColumnDimension('G')->setAutoSize(true);
		$sheet->setCellValue('I3', 'Status')->getColumnDimension('H')->setAutoSize(true);

		$sheet->mergeCells('A1:H1');
		$sheet->mergeCells('A2:H2');
		$sheet->mergeCells('A3:A4');
		$sheet->mergeCells('B3:B4');
		$sheet->mergeCells('C3:C4');
		$sheet->mergeCells('D3:D4');
		$sheet->mergeCells('E3:E4');
		$sheet->mergeCells('F3:F4');
		$sheet->mergeCells('G3:G4');
		$sheet->mergeCells('H3:H4');
		$sheet->mergeCells('I3:I4');

		$styleArray = [
			'font' => [
				'bold' => true,
			],
			'alignment' => [
				'horizontal' => \PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER,
				'vertical' 	=> Alignment::VERTICAL_CENTER
			],
			'borders' => [
				'allBorders' => [
					'borderStyle' => \PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN,
					'color' => ['argb' => Color::COLOR_BLACK],
				],
			],

			'fill' => [
				'fillType' => Fill::FILL_SOLID,
				'startColor' => [
					'argb' => Color::COLOR_GREEN,
				],
			],
		];

		$styleArrayHead = [
			'font' => [
				'bold' => true,
			],
			'alignment' => [
				'horizontal' => \PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER,
				'vertical' 	=> Alignment::VERTICAL_CENTER
			]
		];

		//style for active cell [border]
		$styleThinBlackBorderOutline = [

			'borders' => [
				'allBorders' => [
					'borderStyle' => \PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN,
					'color' => ['argb' => Color::COLOR_BLACK],
				],
			]

		];

		$sheet->getStyle('B2:B9999')->getAlignment()->setHorizontal('left');
		$sheet->getStyle('A1:I1')->applyFromArray($styleArrayHead);
		$sheet->getStyle('A3:I3')->applyFromArray($styleArray);
		$sheet->getStyle('A4:I4')->applyFromArray($styleArray);

		/* Fill data [BEGIN]*/
		$i = 1;
		$startingRow 	= 5;

		foreach ($rows as $r) {
			//set variable
			$no 	  	 	= $i++;
			$nik 	     	= $r['code'];
			$fullname 	 	= $r['person']['first_name'] . " " . $r['person']['last_name'];
			$email		 	= $r['user']['email'];		

			if ($r['person']['gender'] == 'M') {
				$gender = 'Pria';
			} elseif ($r['person']['gender'] == 'F') {
				$gender = 'Wanita';
			} else {
				$gender = 'Tidak ada informasi';
			}

			$birth_date	 = $r['person']['birth_date'];
			$birth_place = $r['person']['birth_place'];
			$type_name 	 = $r['type']['name'];
			$status 	 = $r['status']['description'];

			//insert variable into cell
			$sheet->setCellValueByColumnAndRow(1, $startingRow, $no); /* Column nomor */
			$sheet->setCellValueByColumnAndRow(2, $startingRow, $nik); /* Column NIK */
			$sheet->setCellValueByColumnAndRow(3, $startingRow, $email); /* Column Email */
			$sheet->setCellValueByColumnAndRow(4, $startingRow, $fullname); /* Column Nama */
			$sheet->setCellValueByColumnAndRow(5, $startingRow, $gender); /* Column description */
			$sheet->setCellValueByColumnAndRow(6, $startingRow, $birth_date); /* Column start_date */
			$sheet->setCellValueByColumnAndRow(7, $startingRow, $birth_place); /* Column end_date */
			$sheet->setCellValueByColumnAndRow(8, $startingRow, $type_name); /* Column end_date */
			$sheet->setCellValueByColumnAndRow(9, $startingRow, $status); /* Column end_date */

			//give style border to active cell
			$sheet->getStyleByColumnAndRow(1, $startingRow, $no)->applyFromArray($styleThinBlackBorderOutline);
			$sheet->getStyleByColumnAndRow(2, $startingRow, $nik)->applyFromArray($styleThinBlackBorderOutline);
			$sheet->getStyleByColumnAndRow(3, $startingRow, $nik)->applyFromArray($styleThinBlackBorderOutline);
			$sheet->getStyleByColumnAndRow(4, $startingRow, $fullname)->applyFromArray($styleThinBlackBorderOutline);
			$sheet->getStyleByColumnAndRow(5, $startingRow, $gender)->applyFromArray($styleThinBlackBorderOutline);
			$sheet->getStyleByColumnAndRow(6, $startingRow, $birth_date)->applyFromArray($styleThinBlackBorderOutline);
			$sheet->getStyleByColumnAndRow(7, $startingRow, $birth_place)->applyFromArray($styleThinBlackBorderOutline);
			$sheet->getStyleByColumnAndRow(8, $startingRow, $type_name)->applyFromArray($styleThinBlackBorderOutline);
			$sheet->getStyleByColumnAndRow(9, $startingRow, $status)->applyFromArray($styleThinBlackBorderOutline);

			$startingRow++;
		}
		/* Fill data [END]*/
		
		$date = date('d M Y');

		/* Save to file */
		$writer = IOFactory::createWriter($spreadsheet, "Xlsx"); //Xls is also possible
		$filename = 'Employee Report ' . $date . '.xlsx';

		header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
		header('Content-Disposition: attachment; filename="' . $filename);
		header('Cache-Control: max-age=0');
		ob_end_clean();
		$writer->save('php://output', 'xlsx');
		exit();
	}

	public function downloadPdfDetailAction()
	{
		$post 		= $this->getRequest()->getQuery();
		$sessmgt    = $this->getSession()->get();
		
		$dataArr 	= explode(',', $post['id']);
		$multiple = count($dataArr);
		
		if($multiple == 1){
			$storage = \Neuron\Person\Entity\Storage::factory($this->getDb(), $this->getConfig());
			$cpersons = new \Neuron\Person\Entities($storage);
			$resemp = $cpersons->listPerson($post);

			$emp 		    = $resemp['data']['0'];
			$first_name 	= $emp['first_name'];
			$last_name 		= $emp['last_name'];
			$birth_place	= $emp['birth_place'];
			$birthdate 		= strtotime($emp['birth_date']);
			$birth_date	 	= date("d M Y", $birthdate);

			if($emp['pic_official']){
				if(!file_exists(getcwd() .'/public'. $emp['pic_official'])){
					$picture =  $this->getPublicUrl().'/actor/picture/default';
				}else{
					$picture = $this->getPublicUrl() . "" . $emp['pic_official'];
				}
			}else{
				$picture = $this->getPublicUrl().'/actor/picture/default';
			}
			
			if (class_exists('Neuron\Employee\Entity')) {
				$storage 	= \Neuron\Employee\Entity\Storage::factory($this->getDb(), $this->getConfig());
				$entity 	= new \Neuron\Employee\Entity($storage);
				
				$params		= array('person_id' => $post['id']);
				$employee 	= $entity->load($post['id'], \Neuron\Employee\Entity\Storage::LOADBY_ID);
				$emp		= $entity->pull();
				$code		= $emp['code'];
			}else{
				$code		= '';
			}
			
			$fullname 		= $first_name . " " . $last_name;
			$codes 			= $code;
			

			//get data contact
			if (class_exists('Neuron\Contact\Entity')) {
				$storage = \Neuron\Contact\Entity\Storage::factory($this->getDb(), $this->getConfig());
				$ccontact = new \Neuron\Contact\Entities($storage);

				$storageDetail = \Neuron\Contact\Detail\Storage::factory($this->getDb(), $this->getConfig());
				$cdetail = new \Neuron\Contact\Detail($storageDetail);

				$filter = array('searchField' => 'ref_id', 'searchValue' => $post['id']);
				$datacontact = $ccontact->listContact(0, 999, $filter);
				$contact = array();
				if ($datacontact['rows']) {
					foreach ($datacontact['rows'] as $val) {
						$val['detail'] = array();
						$datadeatail = $cdetail->load($val['id']);
						if ($datadeatail) {
							foreach ($datadeatail as $detail) {
								array_push($val['detail'], $detail);
							}
						}
						array_push($contact, $val);
					}
				}

				//pecah array dari data contact
				$address['data'] = array();
				$personals['data'] = array();
				$contacts['data'] = array();
				foreach ($contact as $c) {
					if ($c['relation_type_id'] == 1) {

						foreach ($c['detail'] as $d) {
							if ($d['type_id'] == 1) {
								array_push($address['data'], $d);
							} elseif ($d['type_id'] == 2) {
								array_push($personals['data'], $d);
							} elseif ($d['type_id'] == 3) {
								array_push($contacts['data'], $d);
							}
						}
					}
				}
			} else {
				$contact 	= null;
				$address 	= null;
				$personals 	= null;
				$contacts 	= null;
			}

			//variable dari contact
			$addres  = $address['data'][0]['basic'] . " " . $address['data'][0]['district'] . " " . $address['data'][0]['city_name'] . " " . $address['data'][0]['province_name'] . " zipcode " . $address['data'][0]['post_code'];
			$phone   = $personals['data'][0]['description'];
			$email   = $contacts['data'][0]['description'];

			$mpdf 	 = new Mpdf();
			$mpdf    = new \Mpdf\Mpdf();
			
			$content		.= "<table border=\"0\" cellspacing=\"0\" cellpadding=\"5\" width=\"100%\">";
			$content		.= 		"<tr>";
			$content		.= 			"<td style=\"width:30%;\" rowspan=\"10\" align=\"center\"><img src=" . $picture . " width=\"210\"></td>";
			$content		.= 			"<td style=\"width:70%; padding-left:20px;  padding-bottom:20px; \" colspan=\"3\"><h2 style=\"text-indent:center;\" >" . $fullname . "</h2></td>";
			$content		.= 		"</tr>";
			$content		.= 		"<tr ><td style=\"font-size:12px; width:25%; padding-left:20px;\">Nik</td><td style=' width:5%;'> : </td><td style=\"font-size:12px; width:70%;\"><p>" . $codes . "</p></td></tr>";
			$content		.= 		"<tr ><td style=\"font-size:12px; width:25%; padding-left:20px;\">Alamat</td><td style=' width:5%;'> : </td><td style=\"font-size:12px; width:70%;\"><p>" . $addres . "</p></td></tr>";
			$content		.= 		"<tr ><td style=\"font-size:12px; width:25%; padding-left:20px;\">Telepon</td><td style=' width:5%;'> : </td><td style=\"font-size:12px; width:70%;\"><p>" . $phone . "</p></td></tr>";
			$content		.= 		"<tr ><td style=\"font-size:12px; width:25%; padding-left:20px;\">Email</td><td style=' width:5%;'> : </td><td style=\"font-size:12px; width:70%;\"><p>" . $email . "</p></td></tr>";
			$content		.= 		"<tr ><td style=\"font-size:12px; width:25%; padding-left:20px;\">Tempat / Tanggal Lahir</td><td style=' width:5%;'> : </td><td style=\"font-size:12px; width:70%;\"><p>" . $birth_place . ", " . $birth_date . "</p></td></tr>";
			$content		.= "</table>";

			/* Formal Education [BEGIN] */
			$content 		.= "<h3 style='margin-top:30px; margin-bottom:0px;'> " . $this->translate('Formal Education') . " </h3>";
			$content 		.= "<hr style='margin-top:5px;'>";


			$content 		.= "<table style=\"width:100%; font-size:12px;border: 1px solid black;border-collapse: collapse;\" border =\"1\">";
			$content 		.= "	<thead>";
			$content 		.= "		<tr style=\"background-color:yellow;\">";
			$content 		.= "			<th align=\"center\">" . $this->translate('No.') . "</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('Institution') . "</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('City') . "</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('Periode') . "</th>";
			$content 		.= "		</tr>";
			$content 		.= "	</thead>";
			$content 		.= "<tbody>";

			$storage = \Neuron\Person\Education\Storage::factory($this->getDb(), $this->getConfig());
			$cedu = new \Neuron\Person\Educations($storage);

			$person_id = array('person_id' => $post['id'], 'education_type' => 'FORMAL');
			$education = $cedu->listdata($person_id);

			$resedu = json_encode($education);
			$objedu = json_decode($resedu);

			$dataedu = $objedu->data;
			if (count($dataedu)) {
				$no = 1;
				foreach ($dataedu as $edu) {
					$content 	.= "	<tr>";
					$content 	.= "		<td>" . $no . "</td>";
					$content 	.= "		<td>" . $edu->institution . "</td>";
					$content 	.= "		<td>" . $edu->city_name . "</td>";
					$content 	.= "		<td>" . $edu->year_entry . " - " . $edu->year_graduated . "</td>";
					$content 	.= "	</tr>";
					$no++;
				}
			} else {
				$content 	.= "<tr>";
				$content 	.= "	<td colspan=\"4\" align=\"center\"> " . $this->translate('No Data') . " </td>";
				$content 	.= "</tr>";
			}
			$content 		.= "</tbody>";
			$content 		.= "</table>";

			/* Formal Education [END] */

			/* informal Education [BEGIN] */
			$content 		.= "<h3 style='margin-top:30px; margin-bottom:0px;'>  " . $this->translate('Non Formal Education') . " </h3>";
			$content 		.= "<hr style='margin-top:5px;'>";


			$content 		.= "<table style=\"width:100%; font-size:12px;border: 1px solid black;border-collapse: collapse;\" border =\"1\">";
			$content 		.= "	<thead>";
			$content 		.= "		<tr style=\"background-color:yellow;\">";
			$content 		.= "			<th align=\"center\">" . $this->translate('No.') . "</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('Institution') . "</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('City') . "</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('Periode') . "</th>";
			$content 		.= "		</tr>";
			$content 		.= "	</thead>";
			$content 		.= "<tbody>";

			$storage = \Neuron\Person\Education\Storage::factory($this->getDb(), $this->getConfig());
			$cedu = new \Neuron\Person\Educations($storage);

			$person_id = array('person_id' => $post['id'], 'education_type' => 'INFORMAL');
			$education = $cedu->listdata($person_id);

			$resedu = json_encode($education);
			$objedu = json_decode($resedu);

			$dataedu = $objedu->data;
			if (count($dataedu)) {
				$no = 1;
				foreach ($dataedu as $edu) {
					$content 	.= "	<tr>";
					$content 	.= "		<td>" . $no . "</td>";
					$content 	.= "		<td>" . $edu->institution . "</td>";
					$content 	.= "		<td>" . $edu->city_name . "</td>";
					$content 	.= "		<td>" . $edu->year_entry . " - " . $edu->year_graduated . "</td>";
					$content 	.= "	</tr>";
					$no++;
				}
			} else {
				$content 	.= "<tr>";
				$content 	.= "	<td colspan=\"4\" align=\"center\"> " . $this->translate('No Data') . " </td>";
				$content 	.= "</tr>";
			}
			$content 		.= "</tbody>";
			$content 		.= "</table>";

			/* Informal Education [END] */

			/* Experience [BEGIN] */
			$content 		.= "<h3 style='margin-top:30px; margin-bottom:0px;'> " . $this->translate('Experience') . " </h3>";
			$content 		.= "<hr style='margin-top:5px;'>";

			$content 		.= "<table style=\"width:100%; font-size:12px;border: 1px solid black;border-collapse: collapse;\" border =\"1\">";
			$content 		.= "	<thead>";
			$content 		.= "		<tr style=\"background-color:yellow;\">";
			$content 		.= "			<th align=\"center\">" . $this->translate('No.') . "</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('Company name') . "</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('Position') . "</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('Periode') . "</th>";
			$content 		.= "		</tr>";
			$content 		.= "	</thead>";
			$content 		.= "<tbody>";

			$storage = \Neuron\Person\Experience\Storage::factory($this->getDb(), $this->getConfig());
			$cexp = new \Neuron\Person\Experiences($storage);

			$experiences = $cexp->listdata($person_id);

			$resexp = json_encode($experiences);
			$objexp = json_decode($resexp);

			$dataexp = $objexp->data;

			if (count($dataexp)) {
				$nos = 1;
				foreach ($dataexp as $exp) {
					$dateStringStart = DateTime::createFromFormat('Ym', $exp->period_start)->format('M Y');
					if($exp->period_end){
						$dateStringEnd = DateTime::createFromFormat('Ym', $exp->period_end)->format('M Y');
					}else{
						$dateStringEnd = $this->translate('Now');
					}	

					$content 	.= "	<tr>";
					$content 	.= "		<td>" . $nos . "</td>";
					$content 	.= "		<td>" . $exp->company_name . "</td>";
					$content 	.= "		<td>" . $exp->position . "</td>";
					$content 	.= "		<td>" . $dateStringStart . " - " . $dateStringEnd . "</td>";
					$content 	.= "	</tr>";
					$nos++;
				}
			} else {
				$content 	.= "<tr>";
				$content 	.= "	<td colspan=\"4\" align=\"center\"> " . $this->translate('No Data') . " </td>";
				$content 	.= "</tr>";
			}
			$content 		.= "</tbody>";
			$content 		.= "</table>";
			/* Experience [END] */

			/* Health hystory [BEGIN] */
			$content 		.= "<h3 style='margin-top:30px; margin-bottom:0px;'> " . $this->translate('Medical History') . " </h3>";
			$content 		.= "<hr style='margin-top:5px; margin-bottom:10px;'>";
			
			$content 		.= "<h5> " . $this->translate('Light Treatment') . " </h5>";
			$content 		.= "<table style=\"width:100%; font-size:12px;border: 1px solid black;border-collapse: collapse;\" border =\"1\">";
			$content 		.= "	<thead>";
			$content 		.= "		<tr style=\"background-color:yellow;\">";
			$content 		.= "			<th align=\"center\">" . $this->translate('Description') . "</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('Treatment Type') . "</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('Treatment Period') . "</th>";
			$content 		.= "		</tr>";
			$content 		.= "	</thead>";
			$content 		.= "<tbody>";

			$storage = \Neuron\Person\Medical\Storage::factory($this->getDb(), $this->getConfig());
			$cmed = new \Neuron\Person\Medicals($storage);

			//general
			$mgeneral = array('person_id' => $post['id'], 'medical_type' => 'GENERAL');
			$medical = $cmed->listdata($mgeneral);

			$resmedical = json_encode($medical);
			$objmedical = json_decode($resmedical);

			$datamedical = $objmedical->data;
			if (count($datamedical)) {

				foreach ($datamedical as $med) {

					$content 	.= "	<tr>";
					$content 	.= "		<td>" . $med->medical_description . "</td>";
					$content 	.= "		<td>" . $med->medical_type_name . "</td>";
					$content 	.= "		<td>" . $med->treatment_dat . "</td>";
					$content 	.= "	</tr>";
				}
			} else {
				$content 	.= "<tr>";
				$content 	.= "	<td colspan=\"3\" align=\"center\"> " . $this->translate('No Data') . " </td>";
				$content 	.= "</tr>";
			}
			$content 		.= "</tbody>";
			$content 		.= "</table>";

			//surgary
			$content 		.= "<h5>" . $this->translate('Surgery') . "</h5>";
			$content 		.= "<table style=\"width:100%; font-size:12px;border: 1px solid black;border-collapse: collapse;\" border =\"1\">";
			$content 		.= "	<thead>";
			$content 		.= "		<tr style=\"background-color:yellow;\">";
			$content 		.= "			<th align=\"center\">" . $this->translate('Description') . "</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('Treatment Type') . "</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('Treatment Period') . "</th>";
			$content 		.= "		</tr>";
			$content 		.= "	</thead>";
			$content 		.= "<tbody>";

			$msurgeries = array('person_id' => $post['id'], 'medical_type' => 'SURGERIES');
			$msurgery = $cmed->listdata($msurgeries);

			$ressurgery = json_encode($msurgery);
			$objsurgery = json_decode($ressurgery);

			$datasurgery = $objsurgery->data;
			if (count($datamedical)) {

				foreach ($datasurgery as $ms) {

					$content 	.= "	<tr>";
					$content 	.= "		<td>" . $ms->medical_description . "</td>";
					$content 	.= "		<td>" . $ms->medical_type_name . "</td>";
					$content 	.= "		<td>" . $ms->treatment_dat . "</td>";
					$content 	.= "	</tr>";
				}
			} else {
				$content 	.= "<tr>";
				$content 	.= "	<td colspan=\"3\" align=\"center\"> " . $this->translate('No Data') . " </td>";
				$content 	.= "</tr>";
			}
			$content 		.= "</tbody>";
			$content 		.= "</table>";

			//alergy
			$content 		.= "<h5>" . $this->translate('Allergies History') . "</h5>";
			$content 		.= "<table style=\"width:100%; font-size:12px;border: 1px solid black;border-collapse: collapse;\" border =\"1\">";
			$content 		.= "	<thead>";
			$content 		.= "		<tr style=\"background-color:yellow;\">";
			$content 		.= "			<th align=\"center\">" . $this->translate('Description') . "</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('Treatment Type') . "</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('Treatment Period') . "</th>";
			$content 		.= "		</tr>";
			$content 		.= "	</thead>";
			$content 		.= "<tbody>";

			$malergies = array('person_id' => $post['id'], 'medical_type' => 'ALLERGIES');
			$malergy = $cmed->listdata($malergies);

			$resalergy = json_encode($malergy);
			$objalergy = json_decode($resalergy);

			$dataalergy = $objalergy->data;
			if (count($dataalergy)) {

				foreach ($dataalergy as $ma) {

					$content 	.= "	<tr>";
					$content 	.= "		<td>" . $ma->medical_description . "</td>";
					$content 	.= "		<td>" . $ma->medical_type_name . "</td>";
					$content 	.= "		<td>" . $ma->treatment_dat . "</td>";
					$content 	.= "	</tr>";
				}
			} else {
				$content 	.= "<tr>";
				$content 	.= "	<td colspan=\"3\" align=\"center\"> " . $this->translate('No Data') . " </td>";
				$content 	.= "</tr>";
			}
			$content 		.= "</tbody>";
			$content 		.= "</table>";

			//penyakit turunan
			$content 		.= "<h5>" . $this->translate('Hereditary Desease') . "</h5>";
			$content 		.= "<table style=\"width:100%; font-size:12px;border: 1px solid black;border-collapse: collapse;\" border =\"1\">";
			$content 		.= "	<thead>";
			$content 		.= "		<tr style=\"background-color:yellow;\">";
			$content 		.= "			<th align=\"center\">" . $this->translate('Description') . "</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('Treatment Type') . "</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('Treatment Period') . "</th>";
			$content 		.= "		</tr>";
			$content 		.= "	</thead>";
			$content 		.= "<tbody>";

			$mhereditarys = array('person_id' => $post['id'], 'medical_type' => 'HEREDITARY');
			$hereditary = $cmed->listdata($mhereditarys);
			$reshereditary = json_encode($hereditary);
			$objhereditary = json_decode($reshereditary);

			$datahereditary = $objhereditary->data;
			if (count($datahereditary)) {

				foreach ($datahereditary as $mh) {

					$content 	.= "	<tr>";
					$content 	.= "		<td>" . $mh->medical_description . "</td>";
					$content 	.= "		<td>" . $mh->medical_type_name . "</td>";
					$content 	.= "		<td>" . $mh->treatment_dat . "</td>";
					$content 	.= "	</tr>";
				}
			} else {
				$content 	.= "<tr>";
				$content 	.= "	<td colspan=\"3\" align=\"center\"> " . $this->translate('No Data') . " </td>";
				$content 	.= "</tr>";
			}
			$content 		.= "</tbody>";
			$content 		.= "</table>";

			/* Health hystory [END] */

			/* etc [BEGIN] */
			$content 		.= "<h3 style='margin-top:30px; margin-bottom:0px;'> " . $this->translate('Another Data') . " </h3>";
			$content 		.= "<hr style='margin-top:5px;'>";

			$content 		.= "<table style=\"width:100%; font-size:12px;border: 1px solid black;border-collapse: collapse;\" border =\"1\">";
			$content 		.= "	<thead>";
			$content 		.= "		<tr style=\"background-color:yellow;\">";
			$content 		.= "			<th align=\"center\">No</th>";
			$content 		.= "			<th align=\"center\">Jenis</th>";
			$content 		.= "			<th align=\"center\">Deskripsi</th>";
			$content 		.= "		</tr>";
			$content 		.= "	</thead>";
			$content 		.= "<tbody>";

			$attrModel 		= new Attributes(AttrModel\Storage::factory($this->getDb(), $this->getConfig()));
			$attparams 		= array('person_id' => $post['id']);
			$resultAttr 	= $attrModel->load($post['id'], AttrModel\Storage::LISTBY_PERSONID, $attparams);
			
			$dataAttribute = $resultAttr->data['list'];
			if (count($dataAttribute) > 0) {
				$i = 1;
				foreach ($dataAttribute as $att) {

					$content 	.= "	<tr>";
					$content 	.= "		<td>" . $i . "</td>";
					$content 	.= "		<td>" . $att['attr_code'] . "</td>";
					$content 	.= "		<td>" . $att['attr_value'] . "</td>";
					$content 	.= "	</tr>";

					$i++;
				}
			} else {
				$content 	.= "<tr>";
				$content 	.= "	<td colspan=\"3\" align=\"center\"> No Data </td>";
				$content 	.= "</tr>";
			}
			$content 		.= "</tbody>";
			$content 		.= "</table>";

			/* etc [END] */

			/* Job Position [BEGIN] */
			$content 		.= "<h3 style='margin-top:30px; margin-bottom:0px;'> Posisi Pekerjaan </h3>";
			$content 		.= "<hr style='margin-top:5px;'>";

			$content 		.= "<table style=\"width:100%;font-size:12px;border: 1px solid black;border-collapse: collapse;\" border =\"1\">";
			$content 		.= "	<thead>";
			$content 		.= "		<tr style=\"background-color:yellow;\">";
			$content 		.= "			<th align=\"center\">" . $this->translate('No.') . "</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('Posisi') . "</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('Organisasi') . "</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('Deskripsi Pekerjaan') . "</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('Posisi / Tugas') . "</th>";
			$content 		.= "		</tr>";
			$content 		.= "	</thead>";
			$content 		.= "<tbody>";			
			
			if (class_exists('Neuron\Employee\Entity')) {
				$storage 	= \Neuron\Employee\Job\Storage::factory($this->getDb(), $this->getConfig());
				$jobs	 	= new \Neuron\Employee\Jobs($storage);
				$ohpData 	= new \Neuron\Employee\Job($storage);
				
				$params		= array('person_id' => $post['id']);
				$listJobs 	= $jobs->load($post['id'], \Neuron\Employee\Job\Storage::LISTBY_EMPID);
												
				if (count($listJobs->data['list']) > 0) {
					$nom = 1;
					foreach ($listJobs->data['list'] as $job) {

						if ($job['start_date']) {
							$start_dtm = strtotime($job['start_date']);
							$starts_dtm = date("d M Y", $start_dtm);
						} else {
							$starts_dtm = "Sampai saat ini";
						}

						if ($job['end_date']) {
							$end_dtm = strtotime($job['end_date']);
							$ends_dtm = date("d M Y", $end_dtm);
						} else {
							$ends_dtm = "Sampai saat ini";
						}
						
						$ohpData->ohp_id = $job['ohp_id'];
						$ohps = $ohpData->ohp();
						
						$orgData = $ohps->pull(10);

						$content 	.= "	<tr>";
						$content 	.= "		<td>" . $nom . "</td>";
						$content 	.= "		<td>" . $orgData['title'] . "</td>";
						$content 	.= "		<td>" . $orgData['org_name'] . "</td>";
						$content 	.= "		<td>" . $orgData['description'] . "</td>";
						$content 	.= "		<td>" . $starts_dtm . " - " . $ends_dtm . "</td>";
						$content 	.= "	</tr>";
						$nom++;
					}
				} else {
					$content 	.= "<tr>";
					$content 	.= "	<td colspan=\"4\" align=\"center\"> " . $this->translate('No Data') . " </td>";
					$content 	.= "</tr>";
				}
			
			}else{
				$content 	.= "<tr>";
				$content 	.= "	<td colspan=\"4\" align=\"center\"> " . $this->translate('No Data') . " </td>";
				$content 	.= "</tr>";
			}

			$content 		.= "</tbody>";
			$content 		.= "</table>";
			/* Job Position [END] */
			
			/* Skill [BEGIN] */
			$content 		.= "<h3 style='margin-top:30px; margin-bottom:0px;'> " . $this->translate('Skills') . " </h3>";
			$content 		.= "<hr style='margin-top:5px;'>";

			$content 		.= "<table style=\"width:100%; font-size:12px;border: 1px solid black;border-collapse: collapse;\" border =\"1\">";
			$content 		.= "	<thead>";
			$content 		.= "		<tr style=\"background-color:yellow;\">";
			$content 		.= "			<th align=\"center\">No</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('Skill') . "</th>";
			$content 		.= "			<th align=\"center\">" . $this->translate('Category') . "</th>";
			$content 		.= "		</tr>";
			$content 		.= "	</thead>";
			$content 		.= "<tbody>";
			
			$storage = \Neuron\Person\Skill\Storage::factory($this->getDb(), $this->getConfig());
			$pskill = new \Neuron\Person\Skills($storage);
			
			$person_skill_id = array('person_id' => $post['id']);
			$skill = $pskill->listdata($person_skill_id);

			$resskill = json_encode($skill);
			$objskill = json_decode($resskill);

			$dataskill = $objskill->data;		
			if (count($dataskill)) {
				$nos = 1;
				$skill_code = [];
				foreach ($dataskill as $ski) {
					if($ski->skill_value == 1){
						$value = 'Master';
					}else if($ski->skill_value == 2){
						$value = 'Expert';
					}else if($ski->skill_value == 3){
						$value = 'Intermediate';
					}else{
						$value = 'Based';
					}
					
					$content 	.= "	<tr>";
					$content 	.= "		<td>" . $nos . "</td>";
					$content 	.= "		<td>" . $ski->skill_code . "</td>";
					$content 	.= "		<td>" . $value . "</td>";
					$content 	.= "	</tr>";													
					$nos++;
				}
			} else {
				$content 	.= "<tr>";
				$content 	.= "	<td colspan=\"3\" align=\"center\"> " . $this->translate('No Data') . " </td>";
				$content 	.= "</tr>";
			}					
			$content 		.= "</table>";
			/* Skill [END] */

			$mpdf->WriteHTML($content);

			$mpdf->SetHTMLFooter('
			<table width="100%" style="font-size:12px;">
				<tr>
					<td width="33%">' . $periodText . '</td>
					<td width="33%" align="center">{PAGENO}/{nbpg}</td>
					<td width="33%" style="text-align: right;">' . $fullname . ' NIK: ' . $code . '</td>
				</tr>
			</table>');

			// Output a PDF file directly to the browser
			$mpdf->Output('CV-' . $fullname . '-' . $code . '.pdf', 'I');
		}else{
			$mpdf 	 = new Mpdf();
			$mpdf    = new \Mpdf\Mpdf();
			
			//print_r($multiple);die();

			for($i = 0;$i < $multiple; $i++){
				$mpdf->AddPage();
				$ids['id'] = [];
				$ids['id'] = $dataArr[$i];
				
				$storage = \Neuron\Person\Entity\Storage::factory($this->getDb(), $this->getConfig());
				$cpersons = new \Neuron\Person\Entities($storage);
				$resemp = $cpersons->listPerson($ids);

				$emp 		    = $resemp['data']['0'];
				$first_name 	= $emp['first_name'];
				$last_name 		= $emp['last_name'];
				$birth_place	= $emp['birth_place'];
				$birthdate 		= strtotime($emp['birth_date']);
				$birth_date	 	= date("d M Y", $birthdate);

				if($emp['pic_official']){
					if(!file_exists(getcwd() .'/public'. $emp['pic_official'])){
						$picture =  $this->getPublicUrl().'/actor/picture/default';
					}else{
						$picture = $this->getPublicUrl() . "" . $emp['pic_official'];
					}
				}else{
					$picture = $this->getPublicUrl().'/actor/picture/default';
				}
				
				if (class_exists('Neuron\Employee\Entity')) {
					$storage 	= \Neuron\Employee\Entity\Storage::factory($this->getDb(), $this->getConfig());
					$entity 	= new \Neuron\Employee\Entity($storage);
					
					$params		= array('person_id' => $ids);
					$employee 	= $entity->load($ids, \Neuron\Employee\Entity\Storage::LOADBY_ID);
					$emp		= $entity->pull();
					$code		= $emp['code'];
				}else{
					$code		= '';
				}
				
				$fullname 		= $first_name . " " . $last_name;
				$codes 			= $code;
				

				//get data contact
				if (class_exists('Neuron\Contact\Entity')) {
					$storage = \Neuron\Contact\Entity\Storage::factory($this->getDb(), $this->getConfig());
					$ccontact = new \Neuron\Contact\Entities($storage);

					$storageDetail = \Neuron\Contact\Detail\Storage::factory($this->getDb(), $this->getConfig());
					$cdetail = new \Neuron\Contact\Detail($storageDetail);

					$filter = array('searchField' => 'ref_id', 'searchValue' => $ids);
					$datacontact = $ccontact->listContact(0, 999, $filter);
					$contact = array();
					if ($datacontact['rows']) {
						foreach ($datacontact['rows'] as $val) {
							$val['detail'] = array();
							$datadeatail = $cdetail->load($val['id']);
							if ($datadeatail) {
								foreach ($datadeatail as $detail) {
									array_push($val['detail'], $detail);
								}
							}
							array_push($contact, $val);
						}
					}

					//pecah array dari data contact
					$address['data'] = array();
					$personals['data'] = array();
					$contacts['data'] = array();
					foreach ($contact as $c) {
						if ($c['relation_type_id'] == 1) {

							foreach ($c['detail'] as $d) {
								if ($d['type_id'] == 1) {
									array_push($address['data'], $d);
								} elseif ($d['type_id'] == 2) {
									array_push($personals['data'], $d);
								} elseif ($d['type_id'] == 3) {
									array_push($contacts['data'], $d);
								}
							}
						}
					}
				} else {
					$contact 	= null;
					$address 	= null;
					$personals 	= null;
					$contacts 	= null;
				}
				
				//variable dari contact
				$addres  = $address['data'][0]['basic'] . " " . $address['data'][0]['district'] . " " . $address['data'][0]['city_name'] . " " . $address['data'][0]['province_name'] . " zipcode " . $address['data'][0]['post_code'];
				$phone   = $personals['data'][0]['description'];
				$email   = $contacts['data'][0]['description'];

				// inisialisasi content
				$content 		 = '';

				$content		.= "<table border=\"0\" cellspacing=\"0\" cellpadding=\"5\" width=\"100%\">";
				$content		.= 		"<tr>";
				$content		.= 			"<td style=\"width:30%;\" rowspan=\"10\" align=\"center\"><img src=" . $picture . " width=\"210\"></td>";
				$content		.= 			"<td style=\"width:70%; padding-left:20px;  padding-bottom:20px; \" colspan=\"3\"><h2 style=\"text-indent:center;\" >" . $fullname . "</h2></td>";
				$content		.= 		"</tr>";
				$content		.= 		"<tr ><td style=\"font-size:12px; width:25%; padding-left:20px;\">Nik</td><td style=' width:5%;'> : </td><td style=\"font-size:12px; width:70%;\"><p>" . $codes . "</p></td></tr>";
				$content		.= 		"<tr ><td style=\"font-size:12px; width:25%; padding-left:20px;\">Alamat</td><td style=' width:5%;'> : </td><td style=\"font-size:12px; width:70%;\"><p>" . $addres . "</p></td></tr>";
				$content		.= 		"<tr ><td style=\"font-size:12px; width:25%; padding-left:20px;\">Telepon</td><td style=' width:5%;'> : </td><td style=\"font-size:12px; width:70%;\"><p>" . $phone . "</p></td></tr>";
				$content		.= 		"<tr ><td style=\"font-size:12px; width:25%; padding-left:20px;\">Email</td><td style=' width:5%;'> : </td><td style=\"font-size:12px; width:70%;\"><p>" . $email . "</p></td></tr>";
				$content		.= 		"<tr ><td style=\"font-size:12px; width:25%; padding-left:20px;\">Tempat / Tanggal Lahir</td><td style=' width:5%;'> : </td><td style=\"font-size:12px; width:70%;\"><p>" . $birth_place . ", " . $birth_date . "</p></td></tr>";
				$content		.= "</table>";
				
				/* Formal Education [BEGIN] */
				$content 		.= "<h3 style='margin-top:30px; margin-bottom:0px;'> " . $this->translate('Formal Education') . " </h3>";
				$content 		.= "<hr style='margin-top:5px;'>";

				$content 		.= "<table style=\"width:100%; font-size:12px;border: 1px solid black;border-collapse: collapse;\" border =\"1\">";
				$content 		.= "	<thead>";
				$content 		.= "		<tr style=\"background-color:yellow;\">";
				$content 		.= "			<th align=\"center\">" . $this->translate('No.') . "</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('Institution') . "</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('City') . "</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('Periode') . "</th>";
				$content 		.= "		</tr>";
				$content 		.= "	</thead>";
				$content 		.= "<tbody>";

				$storage = \Neuron\Person\Education\Storage::factory($this->getDb(), $this->getConfig());
				$cedu = new \Neuron\Person\Educations($storage);

				$person_id = array('person_id' => $ids, 'education_type' => 'FORMAL');
				$education = $cedu->listdata($person_id);

				$resedu = json_encode($education);
				$objedu = json_decode($resedu);

				$dataedu = $objedu->data;
				if (count($dataedu)) {
					$no = 1;
					foreach ($dataedu as $edu) {
						$content 	.= "	<tr>";
						$content 	.= "		<td>" . $no . "</td>";
						$content 	.= "		<td>" . $edu->institution . "</td>";
						$content 	.= "		<td>" . $edu->city_name . "</td>";
						$content 	.= "		<td>" . $edu->year_entry . " - " . $edu->year_graduated . "</td>";
						$content 	.= "	</tr>";
						$no++;
					}
				} else {
					$content 	.= "<tr>";
					$content 	.= "	<td colspan=\"4\" align=\"center\"> " . $this->translate('No Data') . " </td>";
					$content 	.= "</tr>";
				}
				$content 		.= "</tbody>";
				$content 		.= "</table>";

				/* Formal Education [END] */
				
				/* Informal Education [BEGIN] */
				$content 		.= "<h3 style='margin-top:30px; margin-bottom:0px;'>  " . $this->translate('Non Formal Education') . " </h3>";
				$content 		.= "<hr style='margin-top:5px;'>";


				$content 		.= "<table style=\"width:100%; font-size:12px;border: 1px solid black;border-collapse: collapse;\" border =\"1\">";
				$content 		.= "	<thead>";
				$content 		.= "		<tr style=\"background-color:yellow;\">";
				$content 		.= "			<th align=\"center\">" . $this->translate('No.') . "</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('Institution') . "</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('City') . "</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('Periode') . "</th>";
				$content 		.= "		</tr>";
				$content 		.= "	</thead>";
				$content 		.= "<tbody>";

				$storage = \Neuron\Person\Education\Storage::factory($this->getDb(), $this->getConfig());
				$cedu = new \Neuron\Person\Educations($storage);

				$person_id = array('person_id' => $ids, 'education_type' => 'INFORMAL');
				$education = $cedu->listdata($person_id);

				$resedu = json_encode($education);
				$objedu = json_decode($resedu);

				$dataedu = $objedu->data;
				if (count($dataedu)) {
					$no = 1;
					foreach ($dataedu as $edu) {
						$content 	.= "	<tr>";
						$content 	.= "		<td>" . $no . "</td>";
						$content 	.= "		<td>" . $edu->institution . "</td>";
						$content 	.= "		<td>" . $edu->city_name . "</td>";
						$content 	.= "		<td>" . $edu->year_entry . " - " . $edu->year_graduated . "</td>";
						$content 	.= "	</tr>";
						$no++;
					}
				} else {
					$content 	.= "<tr>";
					$content 	.= "	<td colspan=\"4\" align=\"center\"> " . $this->translate('No Data') . " </td>";
					$content 	.= "</tr>";
				}
				$content 		.= "</tbody>";
				$content 		.= "</table>";

				/* Informal Education [END] */
				
				/* Experience [BEGIN] */
				$content 		.= "<h3 style='margin-top:30px; margin-bottom:0px;'> " . $this->translate('Experience') . " </h3>";
				$content 		.= "<hr style='margin-top:5px;'>";

				$content 		.= "<table style=\"width:100%; font-size:12px;border: 1px solid black;border-collapse: collapse;\" border =\"1\">";
				$content 		.= "	<thead>";
				$content 		.= "		<tr style=\"background-color:yellow;\">";
				$content 		.= "			<th align=\"center\">" . $this->translate('No.') . "</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('Company name') . "</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('Position') . "</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('Periode') . "</th>";
				$content 		.= "		</tr>";
				$content 		.= "	</thead>";
				$content 		.= "<tbody>";

				$storage = \Neuron\Person\Experience\Storage::factory($this->getDb(), $this->getConfig());
				$cexp = new \Neuron\Person\Experiences($storage);

				$experiences = $cexp->listdata($person_id);

				$resexp = json_encode($experiences);
				$objexp = json_decode($resexp);

				$dataexp = $objexp->data;

				if (count($dataexp)) {
					$nos = 1;
					foreach ($dataexp as $exp) {
						$dateStringStart = DateTime::createFromFormat('Ym', $exp->period_start)->format('M Y');
						if($exp->period_end){
							$dateStringEnd = DateTime::createFromFormat('Ym', $exp->period_end)->format('M Y');
						}else{
							$dateStringEnd = $this->translate('Now');
						}	

						$content 	.= "	<tr>";
						$content 	.= "		<td>" . $nos . "</td>";
						$content 	.= "		<td>" . $exp->company_name . "</td>";
						$content 	.= "		<td>" . $exp->position . "</td>";
						$content 	.= "		<td>" . $dateStringStart . " - " . $dateStringEnd . "</td>";
						$content 	.= "	</tr>";
						$nos++;
					}
				} else {
					$content 	.= "<tr>";
					$content 	.= "	<td colspan=\"4\" align=\"center\"> " . $this->translate('No Data') . " </td>";
					$content 	.= "</tr>";
				}
				$content 		.= "</tbody>";
				$content 		.= "</table>";
				/* Experience [END] */
				
				/* Health hystory [BEGIN] */
				$content 		.= "<h3 style='margin-top:30px; margin-bottom:0px;'> " . $this->translate('Medical History') . " </h3>";
				$content 		.= "<hr style='margin-top:5px; margin-bottom:10px;'>";
				
				$content 		.= "<h5> " . $this->translate('Light Treatment') . " </h5>";
				$content 		.= "<table style=\"width:100%; font-size:12px;border: 1px solid black;border-collapse: collapse;\" border =\"1\">";
				$content 		.= "	<thead>";
				$content 		.= "		<tr style=\"background-color:yellow;\">";
				$content 		.= "			<th align=\"center\">" . $this->translate('Description') . "</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('Treatment Type') . "</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('Treatment Period') . "</th>";
				$content 		.= "		</tr>";
				$content 		.= "	</thead>";
				$content 		.= "<tbody>";

				$storage = \Neuron\Person\Medical\Storage::factory($this->getDb(), $this->getConfig());
				$cmed = new \Neuron\Person\Medicals($storage);

				//general
				$mgeneral = array('person_id' => $ids, 'medical_type' => 'GENERAL');
				$medical = $cmed->listdata($mgeneral);

				$resmedical = json_encode($medical);
				$objmedical = json_decode($resmedical);

				$datamedical = $objmedical->data;
				if (count($datamedical)) {

					foreach ($datamedical as $med) {

						$content 	.= "	<tr>";
						$content 	.= "		<td>" . $med->medical_description . "</td>";
						$content 	.= "		<td>" . $med->medical_type_name . "</td>";
						$content 	.= "		<td>" . $med->treatment_dat . "</td>";
						$content 	.= "	</tr>";
					}
				} else {
					$content 	.= "<tr>";
					$content 	.= "	<td colspan=\"3\" align=\"center\"> " . $this->translate('No Data') . " </td>";
					$content 	.= "</tr>";
				}
				$content 		.= "</tbody>";
				$content 		.= "</table>";

				//surgary
				$content 		.= "<h5>" . $this->translate('Surgery') . "</h5>";
				$content 		.= "<table style=\"width:100%; font-size:12px;border: 1px solid black;border-collapse: collapse;\" border =\"1\">";
				$content 		.= "	<thead>";
				$content 		.= "		<tr style=\"background-color:yellow;\">";
				$content 		.= "			<th align=\"center\">" . $this->translate('Description') . "</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('Treatment Type') . "</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('Treatment Period') . "</th>";
				$content 		.= "		</tr>";
				$content 		.= "	</thead>";
				$content 		.= "<tbody>";

				$msurgeries = array('person_id' => $ids, 'medical_type' => 'SURGERIES');
				$msurgery = $cmed->listdata($msurgeries);

				$ressurgery = json_encode($msurgery);
				$objsurgery = json_decode($ressurgery);

				$datasurgery = $objsurgery->data;
				if (count($datamedical)) {

					foreach ($datasurgery as $ms) {

						$content 	.= "	<tr>";
						$content 	.= "		<td>" . $ms->medical_description . "</td>";
						$content 	.= "		<td>" . $ms->medical_type_name . "</td>";
						$content 	.= "		<td>" . $ms->treatment_dat . "</td>";
						$content 	.= "	</tr>";
					}
				} else {
					$content 	.= "<tr>";
					$content 	.= "	<td colspan=\"3\" align=\"center\"> " . $this->translate('No Data') . " </td>";
					$content 	.= "</tr>";
				}
				$content 		.= "</tbody>";
				$content 		.= "</table>";

				//alergy
				$content 		.= "<h5>" . $this->translate('Allergies History') . "</h5>";
				$content 		.= "<table style=\"width:100%; font-size:12px;border: 1px solid black;border-collapse: collapse;\" border =\"1\">";
				$content 		.= "	<thead>";
				$content 		.= "		<tr style=\"background-color:yellow;\">";
				$content 		.= "			<th align=\"center\">" . $this->translate('Description') . "</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('Treatment Type') . "</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('Treatment Period') . "</th>";
				$content 		.= "		</tr>";
				$content 		.= "	</thead>";
				$content 		.= "<tbody>";

				$malergies = array('person_id' => $ids, 'medical_type' => 'ALLERGIES');
				$malergy = $cmed->listdata($malergies);

				$resalergy = json_encode($malergy);
				$objalergy = json_decode($resalergy);

				$dataalergy = $objalergy->data;
				if (count($dataalergy)) {

					foreach ($dataalergy as $ma) {

						$content 	.= "	<tr>";
						$content 	.= "		<td>" . $ma->medical_description . "</td>";
						$content 	.= "		<td>" . $ma->medical_type_name . "</td>";
						$content 	.= "		<td>" . $ma->treatment_dat . "</td>";
						$content 	.= "	</tr>";
					}
				} else {
					$content 	.= "<tr>";
					$content 	.= "	<td colspan=\"3\" align=\"center\"> " . $this->translate('No Data') . " </td>";
					$content 	.= "</tr>";
				}
				$content 		.= "</tbody>";
				$content 		.= "</table>";

				//penyakit turunan
				$content 		.= "<h5>" . $this->translate('Hereditary Desease') . "</h5>";
				$content 		.= "<table style=\"width:100%; font-size:12px;border: 1px solid black;border-collapse: collapse;\" border =\"1\">";
				$content 		.= "	<thead>";
				$content 		.= "		<tr style=\"background-color:yellow;\">";
				$content 		.= "			<th align=\"center\">" . $this->translate('Description') . "</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('Treatment Type') . "</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('Treatment Period') . "</th>";
				$content 		.= "		</tr>";
				$content 		.= "	</thead>";
				$content 		.= "<tbody>";

				$mhereditarys = array('person_id' => $ids, 'medical_type' => 'HEREDITARY');
				$hereditary = $cmed->listdata($mhereditarys);
				$reshereditary = json_encode($hereditary);
				$objhereditary = json_decode($reshereditary);

				$datahereditary = $objhereditary->data;
				if (count($datahereditary)) {

					foreach ($datahereditary as $mh) {

						$content 	.= "	<tr>";
						$content 	.= "		<td>" . $mh->medical_description . "</td>";
						$content 	.= "		<td>" . $mh->medical_type_name . "</td>";
						$content 	.= "		<td>" . $mh->treatment_dat . "</td>";
						$content 	.= "	</tr>";
					}
				} else {
					$content 	.= "<tr>";
					$content 	.= "	<td colspan=\"3\" align=\"center\"> " . $this->translate('No Data') . " </td>";
					$content 	.= "</tr>";
				}
				$content 		.= "</tbody>";
				$content 		.= "</table>";

				/* Health hystory [END] */
				
				/* etc [BEGIN] */
				$content 		.= "<h3 style='margin-top:30px; margin-bottom:0px;'> " . $this->translate('Another Data') . " </h3>";
				$content 		.= "<hr style='margin-top:5px;'>";

				$content 		.= "<table style=\"width:100%; font-size:12px;border: 1px solid black;border-collapse: collapse;\" border =\"1\">";
				$content 		.= "	<thead>";
				$content 		.= "		<tr style=\"background-color:yellow;\">";
				$content 		.= "			<th align=\"center\">No</th>";
				$content 		.= "			<th align=\"center\">Jenis</th>";
				$content 		.= "			<th align=\"center\">Deskripsi</th>";
				$content 		.= "		</tr>";
				$content 		.= "	</thead>";
				$content 		.= "<tbody>";
				
				$attrModel 		= new Attributes(AttrModel\Storage::factory($this->getDb(), $this->getConfig()));
				$attparams 		= array('person_id' => $ids);
				$resultAttr 	= $attrModel->load($ids, AttrModel\Storage::LISTBY_PERSONID, $attparams);
				
				$dataAttribute = $resultAttr->data['list'];
				if (count($dataAttribute)) {
					$num = 1;
					foreach ($dataAttribute as $attr) {
						$content 	.= "	<tr>";
						$content 	.= "		<td>" . $num . "</td>";
						$content 	.= "		<td>" . $attr['attr_code'] . "</td>";
						$content 	.= "		<td>" . $attr['attr_value'] . "</td>";
						$content 	.= "	</tr>";
						$num++;
					}
				} else {
					$content 	.= "<tr>";
					$content 	.= "	<td colspan=\"3\" align=\"center\"> " . $this->translate('No Data') . " </td>";
					$content 	.= "</tr>";
				}
				$content 		.= "</tbody>";
				$content 		.= "</table>";

				/* etc [END] */
				
				/* Job Position [BEGIN] */
				$content 		.= "<h3 style='margin-top:30px; margin-bottom:0px;'> Posisi Pekerjaan </h3>";
				$content 		.= "<hr style='margin-top:5px;'>";

				$content 		.= "<table style=\"width:100%;font-size:12px;border: 1px solid black;border-collapse: collapse;\" border =\"1\">";
				$content 		.= "	<thead>";
				$content 		.= "		<tr style=\"background-color:yellow;\">";
				$content 		.= "			<th align=\"center\">" . $this->translate('No.') . "</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('Posisi') . "</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('Organisasi') . "</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('Deskripsi Pekerjaan') . "</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('Posisi / Tugas') . "</th>";
				$content 		.= "		</tr>";
				$content 		.= "	</thead>";
				$content 		.= "<tbody>";			
				
				if (class_exists('Neuron\Employee\Entity')) {
					$storage 	= \Neuron\Employee\Job\Storage::factory($this->getDb(), $this->getConfig());
					$jobs	 	= new \Neuron\Employee\Jobs($storage);
					$ohpData 	= new \Neuron\Employee\Job($storage);
					
					$params		= array('person_id' => $ids);
					$listJobs 	= $jobs->load($ids, \Neuron\Employee\Job\Storage::LISTBY_EMPID);
													
					if (count($listJobs->data['list']) > 0) {
						$nom = 1;
						foreach ($listJobs->data['list'] as $job) {

							if ($job['start_date']) {
								$start_dtm = strtotime($job['start_date']);
								$starts_dtm = date("d M Y", $start_dtm);
							} else {
								$starts_dtm = "Sampai saat ini";
							}

							if ($job['end_date']) {
								$end_dtm = strtotime($job['end_date']);
								$ends_dtm = date("d M Y", $end_dtm);
							} else {
								$ends_dtm = "Sampai saat ini";
							}
							
							$ohpData->ohp_id = $job['ohp_id'];
							$ohps = $ohpData->ohp();
							
							$orgData = $ohps->pull(10);

							$content 	.= "	<tr>";
							$content 	.= "		<td>" . $nom . "</td>";
							$content 	.= "		<td>" . $orgData['title'] . "</td>";
							$content 	.= "		<td>" . $orgData['org_name'] . "</td>";
							$content 	.= "		<td>" . $orgData['description'] . "</td>";
							$content 	.= "		<td>" . $starts_dtm . " - " . $ends_dtm . "</td>";
							$content 	.= "	</tr>";
							$nom++;
						}
					} else {
						$content 	.= "<tr>";
						$content 	.= "	<td colspan=\"4\" align=\"center\"> " . $this->translate('No Data') . " </td>";
						$content 	.= "</tr>";
					}
				
				}else{
					$content 	.= "<tr>";
					$content 	.= "	<td colspan=\"4\" align=\"center\"> " . $this->translate('No Data') . " </td>";
					$content 	.= "</tr>";
				}

				$content 		.= "</tbody>";
				$content 		.= "</table>";
				/* Job Position [END] */
				
				/* Skill [BEGIN] */
				$content 		.= "<h3 style='margin-top:30px; margin-bottom:0px;'> " . $this->translate('Skills') . " </h3>";
				$content 		.= "<hr style='margin-top:5px;'>";

				$content 		.= "<table style=\"width:100%; font-size:12px;border: 1px solid black;border-collapse: collapse;\" border =\"1\">";
				$content 		.= "	<thead>";
				$content 		.= "		<tr style=\"background-color:yellow;\">";
				$content 		.= "			<th align=\"center\">No</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('Skill') . "</th>";
				$content 		.= "			<th align=\"center\">" . $this->translate('Category') . "</th>";
				$content 		.= "		</tr>";
				$content 		.= "	</thead>";
				$content 		.= "<tbody>";
				
				$storage = \Neuron\Person\Skill\Storage::factory($this->getDb(), $this->getConfig());
				$pskill = new \Neuron\Person\Skills($storage);
				
				$person_skill_id = array('person_id' => $ids);
				$skill = $pskill->listdata($person_skill_id);

				$resskill = json_encode($skill);
				$objskill = json_decode($resskill);

				$dataskill = $objskill->data;		
				if (count($dataskill)) {
					$nos = 1;
					$skill_code = [];
					foreach ($dataskill as $ski) {
						if($ski->skill_value == 1){
							$value = 'Master';
						}else if($ski->skill_value == 2){
							$value = 'Expert';
						}else if($ski->skill_value == 3){
							$value = 'Intermediate';
						}else{
							$value = 'Based';
						}
						
						$content 	.= "	<tr>";
						$content 	.= "		<td>" . $nos . "</td>";
						$content 	.= "		<td>" . $ski->skill_code . "</td>";
						$content 	.= "		<td>" . $value . "</td>";
						$content 	.= "	</tr>";													
						$nos++;
					}
				} else {
					$content 	.= "<tr>";
					$content 	.= "	<td colspan=\"3\" align=\"center\"> " . $this->translate('No Data') . " </td>";
					$content 	.= "</tr>";
				}					
				$content 		.= "</tbody>";
				$content 		.= "</table>";
				/* Skill [END] */
				
				$mpdf->SetHTMLFooter('
				<table width="100%" style="font-size:12px;">
					<tr>
						<td width="33%">' . $periodText . '</td>
						<td width="33%" align="center">{PAGENO}/{nbpg}</td>
						<td width="33%" style="text-align: right;">' . $fullname . ' NIK: ' . $code . '</td>
					</tr>
				</table>');

				$mpdf->WriteHTML($content);	
				
			}

			// Output a PDF file directly to the browser
			$mpdf->Output('Multiple-CV.pdf', 'I');
		}
		
	}

	public function DetailActionOld()
	{
		$layout = $this->layout();
		if (class_exists('Neuron\Employee\Entity')) {
			$layout->setVariables(['previous' => '<a href="' . $this->getPublicURL() . '/person/index/manage">Manage Employee</a>']);
			$layout->setVariables(['current' => 'Detail Employee']);
		} else {
			$layout->setVariables(['previous' => '<a href="' . $this->getPublicURL() . '/person/index/manage">Manage Person</a>']);
			$layout->setVariables(['current' => 'Detail Person']);
		}

		$this->using('popper');
		$this->using('fontawesome');
		$this->using('exif.js', 18);
		$this->using('croppie', 19);
		$this->usingjs('datatable', 20);
		$this->usingjs('bootbox', 21);
		$this->using('p-loading', 22);
		$this->usingjs('moment', 23);
		$this->using('air-datepicker', 24);
		$this->using('bootstrap-imageupload', 25);
		$this->using('toast', 26);
		$this->using('plupload', 27);
		$this->using('generic', 30);
		$this->using('select2', 31, array(
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/select2.min.js',
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/i18n/id.js',
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/css/select2.min.css',
			'https://cdn.jsdelivr.net/npm/@ttskch/select2-bootstrap4-theme@1.3.2/dist/select2-bootstrap4.min.css',
		));
		$this->using('slick', 33);
		$this->using('jquery.validate', 34);
		$this->using('chart.js', 35, array(
			'https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.8.0/Chart.min.js',
			'https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.8.0/Chart.min.css'
		));
		// $this->using('naf-inside', 99);

		$title = 'Detail Profile';
		$empID = $this->params()->fromQuery('id');

		$sessmgt = $this->getSession()->get();
		$userPerson = $this->getUserPerson($sessmgt['code']);
		// print_r($sessmgt); die();
		$invalid = false;
		if (isset($userPerson['person']['ref_id']) && $userPerson['person']['ref_id'] != $empID) {
			if ($sessmgt['owned_roles']) {
				foreach ($sessmgt['owned_roles'] as $role) {
					if ($role['code'] == 'admin' || $role['code'] == 'HRD') {
						$invalid = false;
						break;
					} else {
						$invalid = true;
					}
				}
			} else {
				$invalid = true;
			}
		}

		return $this->getView('detail', get_defined_vars());
	}

	public function statusAction()
	{

		$this->using('datatable', 19);
		$this->using('jquery.bootgrid', 20);
		$this->usingJs('bootbox', 21);
		$this->using('p-loading', 22);
		$this->usingJs('moment', 23);
		$this->using('bootstrap-datepicker', 24);
		$this->using('bootstrap-imageupload', 25);;
		$this->using('select2', 22, array(
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/select2.min.js',
			/* ini load sesuai bahasa dari session */
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/i18n/id.js',
			/**/
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/css/select2.min.css',
			'https://cdn.jsdelivr.net/npm/@ttskch/select2-bootstrap4-theme@1.3.2/dist/select2-bootstrap4.min.css',
		));
		$this->usingJs('generic', 30);
		$this->using('jquery.validate', 31);

		return $this->getView('liststatus', array('title' => 'Person Status'));
	}

	public function typeAction()
	{

		$this->using('datatable', 19);
		$this->using('jquery.bootgrid', 20);
		$this->usingJs('bootbox', 21);
		$this->using('p-loading', 22);
		$this->usingJs('moment', 23);
		$this->using('bootstrap-datepicker', 24);
		$this->using('bootstrap-imageupload', 25);;
		$this->using('select2', 22, array(
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/select2.min.js',
			/* ini load sesuai bahasa dari session */
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/i18n/id.js',
			/**/
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/css/select2.min.css',
			'https://cdn.jsdelivr.net/npm/@ttskch/select2-bootstrap4-theme@1.3.2/dist/select2-bootstrap4.min.css',
		));
		$this->usingJs('generic', 30);
		$this->using('jquery.validate', 31);

		return $this->getView('listtype', array('title' => 'Person Type'));
	}

	public function wizardAction()
	{

		$layout = $this->layout();
		if (class_exists('Neuron\Employee\Entity')) {
			$layout->setVariables(['previous' => '<a href="' . $this->getPublicURL() . '/person/index/manage">Manage Employee</a>']);
			if (!empty($post['id'])) {
				$layout->setVariables(['current' => 'Edit Employee']);
			} else {
				$layout->setVariables(['current' => 'Create Employee']);
			}
		} else {
			$layout->setVariables(['previous' => '<a href="' . $this->getPublicURL() . '/person/index/manage">Manage Person</a>']);
			if (!empty($post['id'])) {
				$layout->setVariables(['current' => 'Edit Person']);
			} else {
				$layout->setVariables(['current' => 'Create Person']);
			}
		}

		// $this->using('naf-inside', 19);
		$this->using('datatable', 20, array(
			'https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js',
			'https://cdn.datatables.net/1.10.19/js/dataTables.bootstrap4.min.js',
			'https://cdn.datatables.net/1.10.19/css/dataTables.bootstrap4.min.css'
		));
		$this->usingJs('bootbox',21,  array(
			'https://cdnjs.cloudflare.com/ajax/libs/bootbox.js/4.4.0/bootbox.min.js'
		));
		$this->using('p-loading', 22);
		$this->usingJs('moment', 23, array(
			'https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.29.1/moment.min.js'
		));
		$this->using('air-datepicker', 24, array(
			"https://cdnjs.cloudflare.com/ajax/libs/air-datepicker/2.2.3/js/datepicker.min.js",
			"https://cdnjs.cloudflare.com/ajax/libs/air-datepicker/2.2.3/css/datepicker.min.css",
			"https://cdnjs.cloudflare.com/ajax/libs/air-datepicker/2.2.3/js/i18n/datepicker.en.min.js"

		));
		// $this->using('bootstrap-datepicker', 24);
		$this->using('bootstrap-imageupload', 25);
		$this->using('toast', 26);
		$this->using('smart-wizard', 27, array(
			"https://cdn.jsdelivr.net/npm/smartwizard@5/dist/css/smart_wizard_all.min.css",
			"https://cdn.jsdelivr.net/npm/smartwizard@5/dist/js/jquery.smartWizard.min.js"
		));
		$this->using('generic', 30);
		$this->using('select2', 22, array(
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/select2.min.js',
			/* ini load sesuai bahasa dari session */
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/i18n/id.js',
			/**/
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/css/select2.min.css',
			'https://cdn.jsdelivr.net/npm/@ttskch/select2-bootstrap4-theme@1.3.2/dist/select2-bootstrap4.min.css',
		));

		$this->using('jquery.validate', 31, array(
			"https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.19.2/jquery.validate.min.js",
			"https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.19.2/additional-methods.min.js"
		));
		/* get lang */
		$languages = new Actor\User\Languages($this->getActorConfig('user'));
		$languages->load();

		/* get auth types */
		$authentications = new Actor\User\Authentication\Types($this->getActorConfig('user'));
		$authentications->load();

		/* get status */
		$statuses = new Actor\User\Statuses(Actor\User\Status\Storage::factory($this->getDb(), $this->getConfig()));
		$statuses->load();

		/* config */
		$config = $this->getActorConfig();

		$sessmgt = $this->getSession()->get();

		if (class_exists('Neuron\Document\Entity')) {
			$config = $this->getConfig()['upload_document'];
			if (isset($sessmgt['ref_id'])) {
				$config['location'] = $config['location'] . '/' . $sessmgt['ref_id'];
			}

			$var = 'uploader_document';
			$this->using('plupload', 99, array(
				'https://cdnjs.cloudflare.com/ajax/libs/plupload/3.1.2/plupload.full.min.js'
			));
			$upload = new \Neuron\Upload\Upload($var, $config);
		} else {
			$var = null;
			$upload = null;
		}

		$post = $this->getPostParams();
		if (!empty($post['id'])) {
			$post['employee_id'] = $post['id'];
			$employee_id = $post['id'];
			$empID = $post['id'];
			//jika aada parama id

			//load data emp
			$storage = \Neuron\Person\Entity\Storage::factory($this->getDb(), $this->getConfig());
			$cperson = new \Neuron\Person\Entity($storage);
			$cperson->load($post['id']);
			$dataEmp = $cperson->pull();

			$dataEmployee = array_merge($dataEmp);

			//load data emp_attr
			$attrModel 	= new AttrModel(AttrModel\Storage::factory($this->getDb(), $this->getConfig()));
			$resultAttr 	= $attrModel->loadSavedAttribute($post);
			$dataAttribute = $resultAttr->data;

			$dataContract = array();
			if (class_exists("\Neuron\Employee\Entity")) {
				//load data contract
				$storage = \Neuron\Employee\Contract\Storage::factory($this->getDb(), $this->getConfig());
				$ccontract = new \Neuron\Employee\Contract($storage);
				$ccontract->loadEmpContr($post['id']);
				$dataContract = $ccontract->pull();
				$dataEmployee['dataContract'] = $dataContract;
			}


			$storage = \Neuron\Person\Entity\Storage::factory($this->getDb(), $this->getConfig());
			$cpersons = new \Neuron\Person\Entity($storage);
			$dataMapping = $cpersons->loadMapping($post['id']);

			$user = new \Neuron\Actor\User(\Neuron\Actor\User\Storage::factory($this->getDb(), $this->getConfig()), $this->getConfig());
			$user->load(@$dataMapping['user_id'], \Neuron\Actor\User\Storage::LOADBY_ID);
			$dataUser = $user->pull();
			unset($dataUser['password']);
			$dataEmployee['dataUser'] = $dataUser;
			$dataEmployee['email'] = $dataUser['email'];
		}

		if (isset($post['id'])) {
			$title = 'Edit Employee';
			$isUpdate = true;
		} else {
			$isUpdate = false;
			$title = 'Create Employee';
			$empID = rand(-9999999, -100000);
		}

		$add = $this->checkGrants('add_employee');
		$edit = $this->checkGrants('edit_employee');
		$remove = $this->checkGrants('remove_employee');
		$detail = $this->checkGrants('detail_employee');
		$setCategory = $this->checkGrants('set_category_employee');
		$setSalary =  $this->checkGrants('set_salary_employee');

		$flagSourceExt = $this->getConfigExt('flag_source_ext');

		$view = $this->getView('wizard/wizard', get_defined_vars());
		if (class_exists('Neuron\Utility\Security\Csrf')) $token = \Neuron\Utility\Security\Csrf::tokenize($view, 'token', 32, $this);
		return $view;
	}

	public function uploadAction()
	{
		$this->using('generic', 30);
		return $this->getView('upload');
	}

	public function startingGuideAction()
	{
		$attributeType 				= new Type(Type\Storage::factory($this->getDb(), $this->getConfig()));
		$attributeType 				= $attributeType->loadList();
		if ($attributeType->code == 0) {
			$data 					= $attributeType->data;
			if ($data->countTotal > 0) {
				$attributeType 		= true;
			} else {
				$attributeType 		= false;
			}
		} else {
			$attributeType 			= false;
		}


		$entities 					= new Entities(Entity\Storage::factory($this->getDb(), $this->getConfig()));
		$person 					= $entities->load();
		if ($person->code == 0) {
			$data 					= $person->data;
			if ($data['countTotal'] > 0) {
				$person 			= true;
			} else {
				$person 			= false;
			}
		} else {
			$person 					= false;
		}

		$maps 						= new Maps(Map\Storage::factory($this->getDb(), $this->getConfig()));
		$maps 						= $maps->load();
		if ($maps->code == 0) {
			$data 					= $maps->data;
			if ($data['countTotal'] > 0) {
				$maps 			= true;
			} else {
				$maps 			= false;
			}
		} else {
			$maps 					= false;
		}


		return $this->getView('starting-guide', get_defined_vars());
	}

	public function cardAction()
	{
		$add = $this->checkGrants('add_employee');
		$edit = $this->checkGrants('edit_employee');
		$remove = $this->checkGrants('remove_employee');
		$detail = $this->checkGrants('detail_employee');
		$setCategory = $this->checkGrants('set_category_employee');
		$setSalary =  $this->checkGrants('set_salary_employee');
		return $this->getView('card', get_defined_vars());
	}

	public function DetailAction()
	{
		$query 	= $this->getRequest()->getQuery();
		$ref_id = null;
		$dataPerson = null;

		/**
		 * Ambil session ref_id dan session userId nya.
		 * bisa dipake untuk membandingkan apakah user ini pemilik profile atau bukan
		 * kalo pemilik profile, bisa punya hak akses ganti password dll
		 * */
		$session 		= $this->getSession()->owner();
		$userId 		= $session;
		$sessionRefId 	= null;
		$personMap  	= new \Neuron\Person\Map(\Neuron\Person\Map\Storage::factory(
			$this->getDb(),
			$this->getConfig()
		));


		$personMap->load($userId, \Neuron\Person\Map\Storage::LOADBY_USER_ID);
		if ($personMap->person_id) {
			$ref_id 		= $sessionRefId = $personMap->person_id;
		}

		/**
		 * ada ref_id di url?
		 * kalo ada berarti tampilin profile dari user yang ada di url
		 * set ref_id person yang akan diloadnya sesuai dengan yang di url
		 */
		if (isset($query['id'])) {
			$ref_id 	= $query['id'];
		}


		/* Cari tau apakah user yang login = pemilik profile? */
		$isOwner 		= $ref_id == $sessionRefId;

		/* Load person detail */
		if ($ref_id) {
			$person 	= new Entity(Entity\Storage::factory(
				$this->getDb(),
				$this->getConfig()
			));
			$person->load($ref_id);
			if ($person->id) {
				/* Set Data Person */
				$dataPerson 	= $person->pull();
			}

			/* Data tambahan kalo profile yang dilihat adalah profile yang login */
			if ($isOwner) {
				$dataPerson['map']		= $personMap->pull();

				/** get data actor 
				 * dipake untuk ganti password, ngikutin yang sebelumnya aja
				 */
				$actor = new \Neuron\Actor\User(\Neuron\Actor\User\Storage::factory(
					$this->getDb(),
					$this->getConfig()
				));
				$actor->load($personMap->user_id);
				// echo '<pre>'; print_r($actor->pull()); echo '</pre>';die();
				$dataPerson['actor'] 	= [
					"code" => $actor->code,
					"name" => $actor->name,
					"email" => $actor->email,
					"language" => $actor->language,
					"user_status_id" => $actor->statusId,
					"auth_type_id" => $actor->authType,
					"user_id" => $actor->id,
				];
			}

			$dataPerson['is_owner'] = $isOwner;
		}

		/* token untuk change password */
		$token = \Neuron\Utility\Security\Csrf::tokenize(NULL, 'token', 16, $this);

		/* Ambil emp_job kalo ada employee dan organisasi */
		if (class_exists('Neuron\Employee\Entity') && class_exists('Neuron\Organization\Entity')) {
			$empJobs 	= new \Neuron\Employee\Jobs(
				\Neuron\Employee\Jobs\Storage::factory(
					$this->getDb(),
					$this->getConfig()
				)
			);
			$jobs 		= $empJobs->loadEmpJob($ref_id);
			$jobData	= null;

			if ($jobs) {
				foreach ($jobs as $job) {
					/* Check job start date udah melebihi hari ini atau belum */
					if (strtotime($job['start_date']) <= strtotime(date('Y-m-d'))) {
						if (
							strtotime($job['end_date']) > strtotime(date('Y-m-d')) ||
							$job['end_date'] == null
						) {
							$jobData = $job;
						}
					}
				}
			}
			$dataPerson['job'] = $jobData;
		}

		// Untuk payroll slip
		$sessmgt = $this->getSession()->get();
		$active_role = $sessmgt['active_role']['code'];
		$guid = (isset($sessmgt['guid'])) ? $sessmgt['guid'] : '';

		/* Get data bahasa untuk ganti bahasa */
		$languages = new Actor\User\Languages($this->getActorConfig('user'));
		$languages->load();

		// javascript library
		$this->using('popper');
		$this->using('fontawesome');
		$this->using('exif.js', 18);
		$this->using('croppie', 19);
		$this->usingjs('datatable', 20);
		$this->usingjs('bootbox', 21);
		$this->using('p-loading', 22);
		$this->usingjs('moment', 23);
		$this->using('air-datepicker', 24);
		$this->using('bootstrap-imageupload', 25);
		$this->using('toast', 26);
		$this->using('plupload', 27);
		$this->using('generic', 30);
		$this->using('select2', 31, array(
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/select2.min.js',
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/i18n/id.js',
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/css/select2.min.css',
			'https://cdn.jsdelivr.net/npm/@ttskch/select2-bootstrap4-theme@1.3.2/dist/select2-bootstrap4.min.css',
		));
		$this->using('slick', 33);
		$this->using('jquery.validate', 34);
		$this->using('chart.js', 35, array(
			'https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.8.0/Chart.min.js',
			'https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.8.0/Chart.min.css'
		));

		$config = $this->getConfig()['upload_document'];
		if (isset($sessmgt['ref_id'])) {
			$config['location'] = $config['location'] . '/' . $sessmgt['ref_id'];
		}

		$var = 'uploader_document';
		$this->using('plupload', 27);
		$upload = new \Neuron\Upload\Upload($var, $config);

		return $this->getView(
			'detail-new',
			[
				'ref_id' 		=> $ref_id,
				'person' 		=> $dataPerson,
				'token'  		=> $token,
				'var' 			=> $var,
				'upload' 		=> $upload,
				'sessmgt' 		=> $sessmgt,
				'active_role' 	=> $active_role,
				'guid' 			=> $guid,
				'languages' 	=> $languages
			]
		);
	}
	
	public function downloadAllCvAction(){

		$this->using('datatable', 19);
		$this->using('jquery.bootgrid', 20);
		$this->usingJs('bootbox', 21);
		$this->using('p-loading', 22);
		$this->usingJs('moment', 23);
		$this->using('bootstrap-datepicker', 24);
		$this->using('bootstrap-imageupload', 25);;
		$this->using('select2', 22, array(
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/select2.min.js',
			/* ini load sesuai bahasa dari session */
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/i18n/id.js',
			/**/
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/css/select2.min.css',
			'https://cdn.jsdelivr.net/npm/@ttskch/select2-bootstrap4-theme@1.3.2/dist/select2-bootstrap4.min.css',
		));
		$this->usingJs('generic', 30);
		$this->using('jquery.validate', 31);

		return $this->getView('downloadcv', array('title' => 'Download Curriculum Vitae'));
	}
	
	public function downloadPdfCustomAction()
	{
		$post 		= $this->getRequest()->getQuery();
		$sessmgt    = $this->getSession()->get();

		$dataArr 	= explode(',', $post['id']);
		$multiple = count($dataArr);
		
		$activeRole = $sessmgt['active_role']['access_role_id'];

		// load data person
		$storage = \Neuron\Person\Entity\Storage::factory($this->getDb(), $this->getConfig());
		$cpersons = new \Neuron\Person\Entities($storage);
		$resemp = $cpersons->listPerson($post);

		// validasi download session sesuai ref id

		if($activeRole == 1 || $activeRole == 3 || $post['id'] == $sessmgt['ref_id']){
			if($multiple == 1){
				$emp 		    = $resemp['data']['0'];

				if(class_exists("\Neuron\Employee\Entity")){
					$employee       = new \Neuron\Employee\Entity(\Neuron\Employee\Entity\Storage::factory($this->getDb(),$this->getConfig()));
					$employee->load($post['id']);
					//load map
					$user = $employee->_map()->user();
					$user->pictures->load($user->id, \Neuron\Actor\User\Picture\Storage::LISTBY_USER_ID);
					if($user->pictures->count() > 0){
						if($pic = $user->pictures->find('active', 1)){
							$picture = $this->getPublicUrl() . "" . $pic->name;
						}else{
							$picture =  $this->getPublicUrl().'/actor/picture/default';
						}
					}else{
						$picture =  $this->getPublicUrl().'/actor/picture/default';
					}
					$emp = array_merge($employee->pull(),  $employee->detail()->pull(),  $employee->person()->pull());
				}
				
				$code 			= $emp['code'];
				$first_name 	= $emp['first_name'];
				$last_name 		= $emp['last_name'];
				
				$birthdate 		= strtotime($emp['birth_date']);
				$birth_date	 	= date("d M Y", $birthdate);
				
				// if($emp['pic_signature']){
					// if(!file_exists(getcwd() .'/public'. $emp['pic_signature'])){
						// $picture_signature =  $this->getPublicUrl().'/actor/picture/default';
					// }else{
						// $picture_signature = $this->getPublicUrl() . "" . $emp['pic_signature'];
					// }
				// }else{
					// $picture_signature = $this->getPublicUrl().'/actor/picture/default';
				// }
				
				$picture_signature = $this->getPublicUrl() . "" . $emp['pic_signature'];
				$picture_signature_dir = $this->getPublicUrl().'/userfiles/signature/80080201.jpg';

				$fullname 		= $first_name . " " . $last_name;
				$codes 			= $code;

				//get data contact
				if (class_exists('Neuron\Contact\Entity')) {
					$storage = \Neuron\Contact\Entity\Storage::factory($this->getDb(), $this->getConfig());
					$ccontact = new \Neuron\Contact\Entities($storage);

					$storageDetail = \Neuron\Contact\Detail\Storage::factory($this->getDb(), $this->getConfig());
					$cdetail = new \Neuron\Contact\Detail($storageDetail);

					$filter = array('searchField' => 'ref_id', 'searchValue' => $post['id']);
					$datacontact = $ccontact->listContact(0, 999, $filter);
					$contact = array();
					if ($datacontact['rows']) {
						foreach ($datacontact['rows'] as $val) {
							$val['detail'] = array();
							$datadeatail = $cdetail->load($val['id']);
							if ($datadeatail) {
								foreach ($datadeatail as $detail) {
									array_push($val['detail'], $detail);
								}
							}
							array_push($contact, $val);
						}
					}

					//pecah array dari data contact
					$address['data'] = array();
					$personals['data'] = array();
					$contacts['data'] = array();
					foreach ($contact as $c) {
						if ($c['relation_type_id'] == 1) {

							foreach ($c['detail'] as $d) {
								if ($d['type_id'] == 1) {
									array_push($address['data'], $d);
								} elseif ($d['type_id'] == 2) {
									array_push($personals['data'], $d);
								} elseif ($d['type_id'] == 3) {
									array_push($contacts['data'], $d);
								}
							}
						}
					}
				} else {
					$contact 	= null;
					$address 	= null;
					$personals 	= null;
					$contacts 	= null;
				}

				//variable dari contact
				$addres  = $address['data'][0]['basic'] . " " . $address['data'][0]['district'] . " " . $address['data'][0]['city_name'] . " " . $address['data'][0]['province_name'] . " zipcode " . $address['data'][0]['post_code'];
				$phone   = $personals['data'][0]['description'];
				$email   = $contacts['data'][0]['description'];

				$mpdf 	 = new Mpdf();
				$mpdf    = new \Mpdf\Mpdf();
				
				$content		.= "<table border=\"0\" cellspacing=\"0\" cellpadding=\"5\" width=\"100%\">";
				$content		.= 		"<tr>";
				$content		.= 			"<td style=\"width:70%; padding-right:20px; padding-bottom:10px; font-size:15px;\" colspan=\"3\" >" . $addres . "</td>";
				$content		.= 			"<td style=\"width:30%;\" rowspan=\"10\" align=\"center\"><img src=" . $picture . " width=\"210\"></td>";
				$content		.= 		"</tr>";			
				$content		.= 		"<tr >";
				$content		.= 			"<td style=\"font-size:12px; width:100%; padding-right:20px; font-size:15px;\" colspan=\"3\">" . $this->translate('Phone') . " " . $phone . " - " . $this->translate('Email') . " " . $email . "</td>";
				$content		.= 		"</tr>";
				$content		.= 		"<tr>";
				$content		.= 			"<td style=\"width:70%; padding-right:20px;  padding-bottom:10px; \" colspan=\"3\"><h1 style=\"text-indent:center;\" >" . $fullname . "</h1></td>";
				$content		.= 		"</tr>";
				$content		.= "</table>";

				/* Formal Education [BEGIN] */
				$storage = \Neuron\Person\Education\Storage::factory($this->getDb(), $this->getConfig());
				$cedu = new \Neuron\Person\Educations($storage);

				$person_id = array('person_id' => $post['id'], 'education_type' => 'FORMAL');
				$education = $cedu->listdata($person_id);

				$resedu = json_encode($education);
				$objedu = json_decode($resedu);

				$dataedu = $objedu->data;
				if (count($dataedu)) {
					$content 		.= "<h3 style='margin-top:30px; margin-bottom:0px;'> " . $this->translate('Formal Education') . " </h3>";
					$content 		.= "<hr style='margin-top:5px;'>";
					$content 		.= "<table style=\"width:100%; font-size:13px;\">";
				
					$no = 1;
					foreach ($dataedu as $edu) {
						$content 	.= "	<tr>";
						$content 	.= "		<td style=\"width:70%;\"><b>" . $edu->year_entry . " - " . $edu->year_graduated . ", " . $edu->institution . "</b></td>";
						$content 	.= "		<td style=\"width:30%;\">" . $edu->city_name . "</td>";
						$content 	.= "	</tr>";
						$content 	.= "	<tr>";
						$content 	.= "		<td style=\"width:70%;\">" . $edu->departement . "</td>";
						$content 	.= "		<td style=\"width:30%;\"></td>";
						$content 	.= "	</tr>";
						$no++;
					}

					$content 		.= "</table>";
				}

				/* Formal Education [END] */

				/* Informal Education [BEGIN] */
				$storage = \Neuron\Person\Education\Storage::factory($this->getDb(), $this->getConfig());
				$cedu = new \Neuron\Person\Educations($storage);

				$person_id = array('person_id' => $post['id'], 'education_type' => 'INFORMAL');
				$education = $cedu->listdata($person_id);

				$resedu = json_encode($education);
				$objedu = json_decode($resedu);

				$dataedu = $objedu->data;
				if (count($dataedu) > 0) {
					$content 		.= "<h3 style='margin-top:30px; margin-bottom:0px;'>  " . $this->translate('Non Formal Education') . " </h3>";
					$content 		.= "<hr style='margin-top:5px;'>";
					$content 		.= "<table style=\"width:100%; font-size:13px;\">";

					$no = 1;
					foreach ($dataedu as $edu) {
						$content 	.= "	<tr>";
						$content 	.= "		<td style=\"width:70%;\"><b>" . $edu->year_entry . " - " . $edu->year_graduated . ", " . $edu->institution . "</b></td>";
						$content 	.= "		<td style=\"width:30%;\">" . $edu->city_name . "</td>";
						$content 	.= "	</tr>";
						$content 	.= "	<tr>";
						$content 	.= "		<td style=\"width:70%;\">" . $edu->departement . "</td>";
						$content 	.= "		<td style=\"width:30%;\"></td>";
						$content 	.= "	</tr>";
						$no++;
					}
					
					$content 		.= "</table>";
				}
				/* Informal Education [END] */

				/* Experience [BEGIN] */
				$storage = \Neuron\Person\Experience\Storage::factory($this->getDb(), $this->getConfig());
				$cexp = new \Neuron\Person\Experiences($storage);

				$experiences = $cexp->listdata($person_id);

				$resexp = json_encode($experiences);
				$objexp = json_decode($resexp);

				$dataexp = $objexp->data;
				if (count($dataexp)) {
					$content 		.= "<h3 style='margin-top:30px; margin-bottom:0px;'> " . $this->translate('Experience') . " </h3>";
					$content 		.= "<hr style='margin-top:5px;'>";
					$content 		.= "<table style=\"width:100%; font-size:13px;\">";
				
					$nos = 1;
					foreach ($dataexp as $exp) {
						$dateStringStart = DateTime::createFromFormat('Ym', $exp->period_start)->format('M Y');
						if($exp->period_end){
							$dateStringEnd = DateTime::createFromFormat('Ym', $exp->period_end)->format('M Y');
						}else{
							$dateStringEnd = $this->translate('Now');
						}					
						
						$content 	.= "	<tr>";
						$content 	.= "		<td style=\"width:70%;\"><b>" . $dateStringStart. " - " . $dateStringEnd . ", " . $exp->company_name . "</b></td>";
						$content 	.= "		<td style=\"width:30%;\">" . $exp->city_name . "</td>";
						$content 	.= "	</tr>";
						$content 	.= "	<tr>";
						$content 	.= "		<td style=\"width:70%;\">" . $exp->position . "</td>";
						$content 	.= "		<td style=\"width:30%;\"></td>";
						$content 	.= "	</tr>";
						$content 	.= "	<tr>";
						$content 	.= "		<td style=\"width:70%;\">" . $exp->job_desc . "</td>";
						$content 	.= "		<td style=\"width:30%;\"></td>";
						$content 	.= "	</tr>";
						
						$nos++;
					}
					
					$content 		.= "</table>";
				}
				
				/* Experience [END] */
				
				/* Skill [BEGIN] */
				$storage = \Neuron\Person\Skill\Storage::factory($this->getDb(), $this->getConfig());
				$pskill = new \Neuron\Person\Skills($storage);
				
				$person_skill_id = array('person_id' => $post['id']);
				$skill = $pskill->listdata($person_skill_id);

				$resskill = json_encode($skill);
				$objskill = json_decode($resskill);

				$dataskill = $objskill->data;					
				if (count($dataskill)) {
					$content 		.= "<h3 style='margin-top:30px; margin-bottom:0px;'> " . $this->translate('Skills') . " </h3>";
					$content 		.= "<hr style='margin-top:5px;'>";
					$content 		.= "<table style=\"width:100%; font-size:13px;\">";
				
					$nos = 1;
					$skill_code = [];
					foreach ($dataskill as $ski) {
						$arr['code'] = $ski->skill_code;
						array_push($skill_code, $arr['code']);													
						$nos++;
					}
					$content 	.= "	<tr>";
					$content 	.= "		<td style=\"width:70%;\">" . implode(", ",$skill_code) . "</td>";
					$content 	.= "		<td style=\"width:30%;\"></td>";
					$content 	.= "	</tr>";	
					
					$content 		.= "</table>";
				} 					
					/* Skill [END] */
			
				$content 		.= "<br/><br/><br/><br/><br/>";
				
				$content			.= "<div>";
				$content			.= "	<table style=\"width:100%; font-size:13px;\">";
				$content			.= "		<tr>";
				$content			.= "			<td style=\"width:50%;\" align=\"center\">" . $this->translate('CEO') . "</td>";
				$content			.= "			<td style=\"width:50%;\" align=\"center\">" . $this->translate('Sincerely Yours') . "</td>";
				$content			.= "		</tr>";
				$content			.= "		<tr>";
				$content			.= "			<td style=\"width:30%;\" align=\"center\"><img src=" . $picture_signature_dir . " width=\"210\"></td>";
				$content			.= "			<td style=\"width:30%;\" align=\"center\"><img src=" . $picture_signature . " width=\"210\"></td>";
				$content			.= "		</tr>";
				$content			.= "		<tr>";
				$content			.= "			<td style=\"width:50%;\" align=\"center\">Sriyanto</td>";
				$content			.= "			<td style=\"width:50%;\" align=\"center\">" . $fullname . "</td>";
				$content			.= "		</tr>";
				$content			.= "	</table>";
				$content			.= "</div>";

				$mpdf->WriteHTML($content);

				// Output a PDF file directly to the browser
				$mpdf->Output('CV-' . $fullname . '.pdf', 'I');
			}else{
				$mpdf 	 = new Mpdf();
				$mpdf    = new \Mpdf\Mpdf();

				for($i = 0;$i < $multiple; $i++){
					$mpdf->AddPage();
					$ids['id'] = [];
					$ids['id'] = $dataArr[$i];
					
					$storage = \Neuron\Person\Entity\Storage::factory($this->getDb(), $this->getConfig());
					$cpersons = new \Neuron\Person\Entities($storage);
					$resemp = $cpersons->listPerson($ids);
					
					$emp 		    = $resemp['data']['0'];

					// if(class_exists("\Neuron\Employee\Entity")){
						// $employee       = new \Neuron\Employee\Entity(\Neuron\Employee\Entity\Storage::factory($this->getDb(),$this->getConfig()));
						// $employee->load($dataArr[$i]);
						// $emp = array_merge($employee->pull(),  $employee->detail()->pull(),  $employee->person()->pull());
					// }
					
					if(class_exists("\Neuron\Employee\Entity")){
						$employee       = new \Neuron\Employee\Entity(\Neuron\Employee\Entity\Storage::factory($this->getDb(),$this->getConfig()));
						$employee->load($dataArr[$i]);
						//load map
						$user = $employee->_map()->user();
						$user->pictures->load($user->id, \Neuron\Actor\User\Picture\Storage::LISTBY_USER_ID);
						if($user->pictures->count() > 0){
							if($pic = $user->pictures->find('active', 1)){
								$picture = $this->getPublicUrl() . "" . $pic->name;
							}else{
								$picture =  $this->getPublicUrl().'/actor/picture/default';
							}
						}else{
							$picture =  $this->getPublicUrl().'/actor/picture/default';
						}
						$emp = array_merge($employee->pull(),  $employee->detail()->pull(),  $employee->person()->pull());
					}
					$code 			= $emp['code'];
					$first_name 	= $emp['first_name'];
					$last_name 		= $emp['last_name'];

					$birthdate 		= strtotime($emp['birth_date']);
					$birth_date	 	= date("d M Y", $birthdate);

					$picture_signature = $this->getPublicUrl() . "" . $emp['pic_signature'];
					$picture_signature_dir = $this->getPublicUrl().'/userfiles/signature/80080201.jpg';

					$fullname 		= $first_name . " " . $last_name;
					$codes 			= $code;

					//get data contact
					if (class_exists('Neuron\Contact\Entity')) {
						$storage = \Neuron\Contact\Entity\Storage::factory($this->getDb(), $this->getConfig());
						$ccontact = new \Neuron\Contact\Entities($storage);

						$storageDetail = \Neuron\Contact\Detail\Storage::factory($this->getDb(), $this->getConfig());
						$cdetail = new \Neuron\Contact\Detail($storageDetail);

						$filter = array('searchField' => 'ref_id', 'searchValue' => $ids);
						$datacontact = $ccontact->listContact(0, 999, $filter);
						$contact = array();
						if ($datacontact['rows']) {
							foreach ($datacontact['rows'] as $val) {
								$val['detail'] = array();
								$datadeatail = $cdetail->load($val['id']);
								if ($datadeatail) {
									foreach ($datadeatail as $detail) {
										array_push($val['detail'], $detail);
									}
								}
								array_push($contact, $val);
							}
						}

						//pecah array dari data contact
						$address['data'] = array();
						$personals['data'] = array();
						$contacts['data'] = array();
						foreach ($contact as $c) {
							if ($c['relation_type_id'] == 1) {

								foreach ($c['detail'] as $d) {
									if ($d['type_id'] == 1) {
										array_push($address['data'], $d);
									} elseif ($d['type_id'] == 2) {
										array_push($personals['data'], $d);
									} elseif ($d['type_id'] == 3) {
										array_push($contacts['data'], $d);
									}
								}
							}
						}
					} else {
						$contact 	= null;
						$address 	= null;
						$personals 	= null;
						$contacts 	= null;
					}

					//variable dari contact
					$addres  = $address['data'][0]['basic'] . " " . $address['data'][0]['district'] . " " . $address['data'][0]['city_name'] . " " . $address['data'][0]['province_name'] . " zipcode " . $address['data'][0]['post_code'];
					$phone   = $personals['data'][0]['description'];
					$email   = $contacts['data'][0]['description'];
					
					//inisialisasi content
					$content 		= '';

					$content		.= "<table border=\"0\" cellspacing=\"0\" cellpadding=\"5\" width=\"100%\">";
					$content		.= 		"<tr>";
					$content		.= 			"<td style=\"width:70%; padding-right:20px; padding-bottom:10px; font-size:15px;\" colspan=\"3\" >" . $addres . "</td>";
					$content		.= 			"<td style=\"width:30%;\" rowspan=\"10\" align=\"center\"><img src=" . $picture . " width=\"210\"></td>";
					$content		.= 		"</tr>";			
					$content		.= 		"<tr >";
					$content		.= 			"<td style=\"font-size:12px; width:100%; padding-right:20px; font-size:15px;\" colspan=\"3\">" . $this->translate('Phone') . " " . $phone . " - " . $this->translate('Email') . " " . $email . "</td>";
					$content		.= 		"</tr>";
					$content		.= 		"<tr>";
					$content		.= 			"<td style=\"width:70%; padding-right:20px;  padding-bottom:10px; \" colspan=\"3\"><h1 style=\"text-indent:center;\" >" . $fullname . "</h1></td>";
					$content		.= 		"</tr>";
					$content		.= "</table>";

					/* Formal Education [BEGIN] */
					$storage = \Neuron\Person\Education\Storage::factory($this->getDb(), $this->getConfig());
					$cedu = new \Neuron\Person\Educations($storage);

					$person_id = array('person_id' => $ids, 'education_type' => 'FORMAL');
					$education = $cedu->listdata($person_id);

					$resedu = json_encode($education);
					$objedu = json_decode($resedu);

					$dataedu = $objedu->data;
					if (count($dataedu)) {
						$content 		.= "<h3 style='margin-top:30px; margin-bottom:0px;'> " . $this->translate('Formal Education') . " </h3>";
						$content 		.= "<hr style='margin-top:5px;'>";
						$content 		.= "<table style=\"width:100%; font-size:13px;\">";
						
						$no = 1;
						foreach ($dataedu as $edu) {
							$content 	.= "	<tr>";
							$content 	.= "		<td style=\"width:70%;\"><b>" . $edu->year_entry . " - " . $edu->year_graduated . ", " . $edu->institution . "</b></td>";
							$content 	.= "		<td style=\"width:30%;\">" . $edu->city_name . "</td>";
							$content 	.= "	</tr>";
							$content 	.= "	<tr>";
							$content 	.= "		<td style=\"width:70%;\">" . $edu->departement . "</td>";
							$content 	.= "		<td style=\"width:30%;\"></td>";
							$content 	.= "	</tr>";
							$no++;
						}
						
						$content 		.= "</table>";
					}		
					/* Formal Education [END] */

					/* Informal Education [BEGIN] */
					$storage = \Neuron\Person\Education\Storage::factory($this->getDb(), $this->getConfig());
					$cedu = new \Neuron\Person\Educations($storage);

					$person_id = array('person_id' => $ids, 'education_type' => 'INFORMAL');
					$education = $cedu->listdata($person_id);

					$resedu = json_encode($education);
					$objedu = json_decode($resedu);

					$dataedu = $objedu->data;
					if (count($dataedu) > 0) {
						$content 		.= "<h3 style='margin-top:30px; margin-bottom:0px;'>  " . $this->translate('Non Formal Education') . " </h3>";
						$content 		.= "<hr style='margin-top:5px;'>";
						$content 		.= "<table style=\"width:100%; font-size:13px;\">";

						$no = 1;
						foreach ($dataedu as $edu) {
							$content 	.= "	<tr>";
							$content 	.= "		<td style=\"width:70%;\"><b>" . $edu->year_entry . " - " . $edu->year_graduated . ", " . $edu->institution . "</b></td>";
							$content 	.= "		<td style=\"width:30%;\">" . $edu->city_name . "</td>";
							$content 	.= "	</tr>";
							$content 	.= "	<tr>";
							$content 	.= "		<td style=\"width:70%;\">" . $edu->departement . "</td>";
							$content 	.= "		<td style=\"width:30%;\"></td>";
							$content 	.= "	</tr>";
							$no++;
						}
						
						$content 		.= "</table>";
					}
					/* Informal Education [END] */

					/* Experience [BEGIN] */
					$storage = \Neuron\Person\Experience\Storage::factory($this->getDb(), $this->getConfig());
					$cexp = new \Neuron\Person\Experiences($storage);

					$experiences = $cexp->listdata($person_id);

					$resexp = json_encode($experiences);
					$objexp = json_decode($resexp);

					$dataexp = $objexp->data;
					if (count($dataexp)) {
						$content 		.= "<h3 style='margin-top:30px; margin-bottom:0px;'> " . $this->translate('Experience') . " </h3>";
						$content 		.= "<hr style='margin-top:5px;'>";
						$content 		.= "<table style=\"width:100%; font-size:13px;\">";

						$nos = 1;
						foreach ($dataexp as $exp) {
							$dateStringStart = DateTime::createFromFormat('Ym', $exp->period_start)->format('M Y');
							if($exp->period_end){
								$dateStringEnd = DateTime::createFromFormat('Ym', $exp->period_end)->format('M Y');
							}else{
								$dateStringEnd = $this->translate('Now');
							}					
							
							$content 	.= "	<tr>";
							$content 	.= "		<td style=\"width:70%;\"><b>" . $dateStringStart. " - " . $dateStringEnd . ", " . $exp->company_name . "</b></td>";
							$content 	.= "		<td style=\"width:30%;\">" . $exp->city_name . "</td>";
							$content 	.= "	</tr>";
							$content 	.= "	<tr>";
							$content 	.= "		<td style=\"width:70%;\">" . $exp->position . "</td>";
							$content 	.= "		<td style=\"width:30%;\"></td>";
							$content 	.= "	</tr>";
							$content 	.= "	<tr>";
							$content 	.= "		<td style=\"width:70%;\">" . $exp->job_desc . "</td>";
							$content 	.= "		<td style=\"width:30%;\"></td>";
							$content 	.= "	</tr>";
							
							$nos++;
						}
						
						$content 		.= "</table>";
					}
					/* Experience [END] */
					
					/* Skill [BEGIN] */
					$storage = \Neuron\Person\Skill\Storage::factory($this->getDb(), $this->getConfig());
					$pskill = new \Neuron\Person\Skills($storage);
					
					$person_skill_id = array('person_id' => $ids);
					$skill = $pskill->listdata($person_skill_id);

					$resskill = json_encode($skill);
					$objskill = json_decode($resskill);

					$dataskill = $objskill->data;					
					if (count($dataskill)) {
						$content 		.= "<h3 style='margin-top:30px; margin-bottom:0px;'> " . $this->translate('Skills') . " </h3>";
						$content 		.= "<hr style='margin-top:5px;'>";
						$content 		.= "<table style=\"width:100%; font-size:13px;\">";
					
						$nos = 1;
						$skill_code = [];
						foreach ($dataskill as $ski) {
							$arr['code'] = $ski->skill_code;
							array_push($skill_code, $arr['code']);													
							$nos++;
						}
						$content 	.= "	<tr>";
						$content 	.= "		<td style=\"width:70%;\">" . implode(", ",$skill_code) . "</td>";
						$content 	.= "		<td style=\"width:30%;\"></td>";
						$content 	.= "	</tr>";	
						
						$content 		.= "</table>";
					}				
					
					/* Skill [END] */
					
					$content 		.= "<br/><br/><br/><br/><br/>";
				
					$content			.= "<div>";
					$content			.= "	<table style=\"width:100%; font-size:13px;\">";
					$content			.= "		<tr>";
					$content			.= "			<td style=\"width:50%;\" align=\"center\">" . $this->translate('CEO') . "</td>";
					$content			.= "			<td style=\"width:50%;\" align=\"center\">" . $this->translate('Sincerely Yours') . "</td>";
					$content			.= "		</tr>";
					$content			.= "		<tr>";
					$content			.= "			<td style=\"width:30%;\" align=\"center\"><img src=" . $picture_signature_dir . " width=\"210\"></td>";
					$content			.= "			<td style=\"width:30%;\" align=\"center\"><img src=" . $picture_signature . " width=\"210\"></td>";
					$content			.= "		</tr>";
					$content			.= "		<tr>";
					$content			.= "			<td style=\"width:50%;\" align=\"center\">Sriyanto</td>";
					$content			.= "			<td style=\"width:50%;\" align=\"center\">" . $fullname . "</td>";
					$content			.= "		</tr>";
					$content			.= "	</table>";
					$content			.= "</div>";

					$mpdf->WriteHTML($content);			
				}
				// Output a PDF file directly to the browser
				$mpdf->Output('Multiple-CV.pdf', 'I');
			}
		} else {
			return $this->getView('404');	
		};
			
	}
}

